
//--------------------------------------------------------------------------------------
// File: PointSprite.fx
// position, WVPBuffer
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// Constant Buffer Variables
//--------------------------------------------------------------------------------------
/*
cbuffer WVPBuffer : register( b0 )
{
	matrix world;
	matrix view;
	matrix projection;
	float2 ParticleSize;  // p[eBN̑傫
	float2 dummy;
}
*/
//texture
Texture2D tex2d : register( t0 );
SamplerState samp : register( s0 );


//--------------------------------------------------------------------------------------
struct VS_INPUT
{
    float4 pos : POSITION;
    float4 tex4 : TEXCOORD;
};
/*
struct GS_INPUT
{
    float4 pos : SV_POSITION;
    float4 tex4 : TEXTURE;         // eNX`W
};
*/

struct PS_INPUT
{
    float4 pos : SV_POSITION;
    float2 tex : TEXTURE;         // eNX`W
};

//--------------------------------------------------------------------------------------
// Vertex Shader
//--------------------------------------------------------------------------------------
VS_INPUT VS( VS_INPUT input)
{
	return input;
}

//--------------------------------------------------------------------------------------
// Geometry Shader
//--------------------------------------------------------------------------------------
[maxvertexcount(4)]
void GS( point VS_INPUT input[1],
             inout TriangleStream<PS_INPUT> ParticleStream )
{
	
	
    float4 posx1y1 = float4(input[0].pos.x, input[0].pos.y, 0.0, 1.0);
    float4 posx1y2 = float4(input[0].pos.x, input[0].pos.w, 0.0, 1.0);
    float4 posx2y1 = float4(input[0].pos.z, input[0].pos.y, 0.0, 1.0);
    float4 posx2y2 = float4(input[0].pos.z, input[0].pos.w, 0.0, 1.0);
    /*
    float4 posLT = float4(-0.5, 0.5, 0.0, 1.0);
    float4 posLB = float4(-0.5, -0.5, 0.0, 1.0);
    float4 posRT = float4( 0.5, 0.5, 0.0, 1.0);
    float4 posRB = float4( 0.5, -0.5, 0.0, 1.0);
    */
    
    // ̓_̈ʒu(ˉeWn)vZďo.
    PS_INPUT output;
    output.pos = posx1y1;
    output.tex = float2(input[0].tex4.x,input[0].tex4.w);
    //output.tex = float2(0.0,1.0);
    ParticleStream.Append(output);

    // ̓_̈ʒu(ˉeWn)vZďo.
    output.pos = posx1y2;
    output.tex = float2(input[0].tex4.x ,input[0].tex4.y);
    //output.tex = float2(0.0,0.0);
    ParticleStream.Append(output);

    // E̓_̈ʒu(ˉeWn)vZďo.
    output.pos = posx2y1;
    output.tex = float2(input[0].tex4.z,input[0].tex4.w);
    //output.tex = float2(1.0,1.0);
    ParticleStream.Append(output);

    // E̓_̈ʒu(ˉeWn)vZďo.
    output.pos = posx2y2;
    output.tex = float2(input[0].tex4.z ,input[0].tex4.y);
    //output.tex = float2(1.0,0.0);
    ParticleStream.Append(output);
    
    ParticleStream.RestartStrip();
    
}

//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------

float4 PS( PS_INPUT input ) : SV_Target
{
    return tex2d.Sample( samp, input.tex );  // * vMeshColor;
}
