
#define _CRT_SECURE_NO_DEPRECATE

#include "PointSpriteRenderer.h"
#define PI		(3.141529f)


PointSpriteRenderer::PointSpriteRenderer(DX11_CORE* dx11_core, CommonShader* comShader, CommonTexture* comTexture, const TCHAR* texturepath)
		: BasicRenderer(dx11_core, comShader, comTexture,0,0){

	m_texturepath = _tcsdup(texturepath);
	m_vertex_max_count = 0;
	
	m_dx11_core = dx11_core;
	

//DXnIuWFNgϐNULLZbg.
	m_pGeometryShader = NULL;
	m_pTextureRV = NULL;
	m_pSampler = NULL;

	
	m_pPointSize.x = 0.1f;
	m_pPointSize.y = 0.1f;

}


PointSpriteRenderer::~PointSpriteRenderer(){

    SAFE_RELEASE( m_pSampler );
	SAFE_RELEASE(m_pDepthStencilState );

	if( m_pTextureRV ) m_comTexture->UnloadTexture(m_pTextureRV);
	
	if( m_pGeometryShader ) m_comShader->UnloadShader((LPVOID)m_pGeometryShader);

	delete [] m_texturepath;
}





HRESULT PointSpriteRenderer::InitShader(){
	TCHAR filepath[MAX_PATH];
	GetAttachedFileName(filepath, _T("resource\\PointSpriteRenderer.sh"));

	//Vertex Shader--------------------------------------
    // Define the input layout
    D3D11_INPUT_ELEMENT_DESC layout[] =
    {
        { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },

    };
	UINT numElements = ARRAYSIZE( layout );
	m_pVertexShader = m_comShader->LoadVertexShader(filepath, "VS_point", "vs_4_0", layout, numElements, &m_pVertexLayout);


//Geometry Shader-----------------------------------------
	m_pGeometryShader = m_comShader->LoadGeometryShader(filepath, "GS", "gs_4_0");

//Pixel Shader-----------------------------------------
	m_pPixelShader = m_comShader->LoadPixelShader(filepath, "PSsimple", "ps_4_0");

//-----------------------------------------------------------------------
//Constant buffer̍쐬
//constant bufferƂ́AJʒu⃏[hϊsȂ,
//CPUGPŮeXbhɃANZXobt@.
//[hs:fglobalԂɐݒuƂ̈ʒu(sړ)(])Zbgs.
//r[s:J猩Wn֕ϊ.
//ˉes:2W֕ϊ


	//projection, view, world matrixes
	D3D11_BUFFER_DESC bd;
	bd.ByteWidth = sizeof( mat44f )*3 + sizeof(float)*4;
    bd.Usage = D3D11_USAGE_DYNAMIC;
    bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	bd.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;	//CPȔ
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;
	//SUBRESOURCEɂ鏉l͐ݒ肵Ȃ

    HRESULT hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pWVPBuffer );
    if( FAILED( hr ) )
        return hr;

/*	//Light position.
	bd.ByteWidth = sizeof( float )*4;	
	hr = pd3dDevice->CreateBuffer( &bd, NULL, &m_pLightBuffer );
    if( FAILED( hr ) )
        return hr;
*/	

//-----------------------------------------------------------
//eNX`̓ǂݍ.
	

	//hr = D3DX11CreateShaderResourceViewFromFile( m_dx11_core->pd3dDevice, m_texturepath, NULL, NULL, &m_pTextureRV, NULL );
	//	if( FAILED( hr ) ){
	//		m_pTextureRV = NULL;
	//	}
	//TEXTURE_INFO texInfo;
	m_pTextureRV = m_comTexture->LoadTexture(m_texturepath, NULL,NULL);

    // eNX`̃TvO(|S\t̕)@̎w.
    D3D11_SAMPLER_DESC sampDesc;
    ZeroMemory( &sampDesc, sizeof(sampDesc) );
    sampDesc.Filter = D3D11_FILTER_MIN_MAG_MIP_LINEAR;
    sampDesc.AddressU = D3D11_TEXTURE_ADDRESS_WRAP;
    sampDesc.AddressV = D3D11_TEXTURE_ADDRESS_WRAP;
    sampDesc.AddressW = D3D11_TEXTURE_ADDRESS_WRAP;
    sampDesc.ComparisonFunc = D3D11_COMPARISON_NEVER;
    sampDesc.MinLOD = 0;
    sampDesc.MaxLOD = D3D11_FLOAT32_MAX;
    hr = m_dx11_core->pd3dDevice->CreateSamplerState( &sampDesc, &m_pSampler );
    if( FAILED( hr ) )
        return hr;


// uhEXe[gEIuWFNg̍쐬
	// p[eBNpuhEXe[gEIuWFNg
	ZeroMemory(&m_BlendDesc, sizeof(D3D11_BLEND_DESC));
	m_BlendDesc.AlphaToCoverageEnable    = FALSE;
	m_BlendDesc.IndependentBlendEnable   = FALSE;
	m_BlendDesc.RenderTarget[0].BlendEnable           = TRUE;
	m_BlendDesc.RenderTarget[0].BlendOp               = D3D11_BLEND_OP_ADD;
	m_BlendDesc.RenderTarget[0].SrcBlend              = D3D11_BLEND_SRC_ALPHA;//D3D11_BLEND_ONE;
	m_BlendDesc.RenderTarget[0].DestBlend             = D3D11_BLEND_ONE;
	m_BlendDesc.RenderTarget[0].BlendOpAlpha          = D3D11_BLEND_OP_ADD;
	m_BlendDesc.RenderTarget[0].SrcBlendAlpha         = D3D11_BLEND_ZERO;
	m_BlendDesc.RenderTarget[0].DestBlendAlpha        = D3D11_BLEND_ZERO;
	m_BlendDesc.RenderTarget[0].RenderTargetWriteMask = D3D11_COLOR_WRITE_ENABLE_ALL;
	//hr = m_dx11_core->pd3dDevice->CreateBlendState(&m_BlendDesc, &m_pBlendState);

	//[xobt@݂Ȃ.
// fvXEXe[gEIuWFNg̍쐬
	// p[eBNpfvXEXe[gEIuWFNg
	//|CgXvCgł̓fvXobt@̃`FbNāAXV͂Ȃ.
	D3D11_DEPTH_STENCIL_DESC DepthStencilState;
	ZeroMemory(&DepthStencilState, sizeof(D3D11_DEPTH_STENCIL_DESC));
	DepthStencilState.DepthEnable = TRUE;
	DepthStencilState.DepthWriteMask = D3D11_DEPTH_WRITE_MASK_ZERO;	//[xobt@݂Ȃ.
	DepthStencilState.DepthFunc = D3D11_COMPARISON_LESS;
	DepthStencilState.StencilEnable = FALSE;
	DepthStencilState.StencilReadMask = D3D11_DEFAULT_STENCIL_READ_MASK;
	DepthStencilState.StencilWriteMask = D3D11_DEFAULT_STENCIL_WRITE_MASK;
//	DepthStencilState.StencilFunc = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilDepthFailOp = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilPassOp = D3D11_STENCIL_OP_KEEP;
//	DepthStencilState.StencilFailOp = D3D11_COMPARISON_ALWAYS;
	hr = m_dx11_core->pd3dDevice->CreateDepthStencilState(&DepthStencilState, &m_pDepthStencilState);


    return S_OK;
}


void PointSpriteRenderer::Draw(UINT particle_count, vec3f* positions){

	//ϊs
	mat44f world_matrix;
	world_matrix.SetIdentity();
	
	//Blendݒ///////////////////////////////
	//ftHg̃uhXe[g.
	ID3D11BlendState*		org_pBlendState;
	FLOAT org_BlendFactor[4];
	UINT org_SampleMask;
	if(m_blend_enable){
		
		//BlendStateIuWFNgT.
		ID3D11BlendState* pBlendState = m_blend_master.find(m_BlendDesc);
		//BlendStateIuWFNg쐬ȂVK쐬
		if(pBlendState == NULL){
			HRESULT hr = m_dx11_core->pd3dDevice->CreateBlendState(&m_BlendDesc, &pBlendState);
		}
		//BlendStateIuWFNgݒ.
		if(pBlendState){
			m_dx11_core->pd3dDC->OMGetBlendState(&org_pBlendState, org_BlendFactor, &org_SampleMask);
			m_dx11_core->pd3dDC->OMSetBlendState(pBlendState, org_BlendFactor, org_SampleMask);
		}
	}
	//XeVݒ////////////////////////////////////
	//ftHg̃XeVXe[g.
	ID3D11DepthStencilState*		org_pDepthStencilState;
	UINT org_StencilRef;
	if(m_pDepthStencilState){
		m_dx11_core->pd3dDC->OMGetDepthStencilState(&org_pDepthStencilState, &org_StencilRef);
		m_dx11_core->pd3dDC->OMSetDepthStencilState(m_pDepthStencilState, 0);
	}

	// Set the input layout
    m_dx11_core->pd3dDC->IASetInputLayout( m_pVertexLayout );
    // Set primitive topology
    m_dx11_core->pd3dDC->IASetPrimitiveTopology( D3D_PRIMITIVE_TOPOLOGY_POINTLIST );

	//萔obt@̏.
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	m_dx11_core->pd3dDC->Map( m_pConstantBuffers[0], 0, D3D11_MAP_WRITE_DISCARD, 0,&mappedResource);
	CopyMemory(mappedResource.pData, &world_matrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 1, m_pViewMatrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 2, m_pProjectionMatrix, sizeof(mat44f));
	CopyMemory((mat44f*)mappedResource.pData + 3, &m_pPointSize, sizeof(vec2f));
	m_dx11_core->pd3dDC->Unmap( m_pConstantBuffers[0], 0);


	//obt@̃Zbg.	
    UINT offset = 0;
    UINT stride = sizeof( vec3f );
    m_dx11_core->pd3dDC->IASetVertexBuffers( 0, 1, &m_pVertexBuffer, &stride, &offset );

	
	//IȒ_obt@(CX^Xp)̍XV (UpdateSubresourcegꍇ).
	//ړĨobt@Usage = D3D11_USAGE_DEFAULT, CPUAccessFlags = 0.
	//ONULL̎VertexBuffer(VRAM)ƓTCYRs[̂,
	//Rs[(CPU)VertexBufferȏ̃TCYmۂĂȂ΂ȂȂ.
	//̂Ƃ܁EZ͖.
//	m_dx11_core->pd3dDC->UpdateSubresource( m_pVertexBuffer, 0, NULL, positions, 0, 0);//sizeof(vec3f) * particle_count
	//: Map/UnmapUpdateSubresourceł͖wǑx͂Ȃ.


    // Render materials
	m_dx11_core->pd3dDC->VSSetShader( m_pVertexShader, NULL, 0 );
	m_dx11_core->pd3dDC->VSSetConstantBuffers(0, 1, m_pConstantBuffers);
	
//	m_dx11_core->pd3dDC->GSSetShader( m_pGeometryShader, NULL, 0 );
//	m_dx11_core->pd3dDC->GSSetConstantBuffers(0, 1, m_pConstantBuffers);
		
	m_dx11_core->pd3dDC->PSSetShader( m_pPixelShader, NULL, 0 );
//	m_dx11_core->pd3dDC->PSSetShaderResources( 0, 1, &(m_pTextureRV) );
	m_dx11_core->pd3dDC->PSSetSamplers( 0, 1, &m_pSampler );
	m_dx11_core->pd3dDC->Draw( particle_count, 0);

	//Blendݒ///////////////////////////////
	if(m_blend_enable){
		m_dx11_core->pd3dDC->OMSetBlendState(org_pBlendState, org_BlendFactor, org_SampleMask);
	}
	if(m_pDepthStencilState){
		m_dx11_core->pd3dDC->OMSetDepthStencilState(org_pDepthStencilState, org_StencilRef);
	}
}

/*
void PointSpriteRenderer::UpdateVertexBuffer(LPVOID pVertex, UINT vertex_count, UINT vertex_stride){
	m_dx11_core->pd3dDC->UpdateSubresource( m_pVertexBuffer, 0, NULL, pVertex, vertex_stride * vertex_count, 0);
}


void PointSpriteRenderer::SetViewMatrixPointer(mat44f* pViewMatrix ){
	m_pViewMatrix = pViewMatrix;
}

void PointSpriteRenderer::SetProjectionMatrixPointer(mat44f* pProjectionMatrix ){
	m_pProjectionMatrix = pProjectionMatrix;
}



void PointSpriteRenderer::SetInstanceCount(int count){
	
	ID3D11Buffer* m_pOldBuffer = NULL;

	if(count == m_vertex_max_count){
		return;
	}

	//łɃobt@ꍇ͋LĂ,
	//Vobt@GPUɃZbgĂÂقRelease	
	if(	m_pVertexBuffer ){
		m_pOldBuffer = m_pVertexBuffer;
	}
	
//------------------------------------------------------------
//Vertex buffer (CX^X)̍쐬.

	//	vec3f* instance_pos = new vec3f[count];
	//	instance_pos[0].Set(1.0f, 0.0f, 0.0f);
	//	instance_pos[1].Set( -1.0f, 0.0f, 0.0f);
	
    D3D11_BUFFER_DESC bd;
	bd.ByteWidth = sizeof( vec3f ) * count;
	bd.Usage = D3D11_USAGE_DEFAULT;		//D3D11_USAGE_DYNAMIC;
    bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
	bd.CPUAccessFlags = 0;				//D3D11_CPU_ACCESS_WRITE;
	bd.MiscFlags = 0;
	bd.StructureByteStride=0;

//	D3D11_SUBRESOURCE_DATA instanceSD;
//	instanceSD.pSysMem = instance_pos;
//	instanceSD.SysMemPitch = 0;
//	instanceSD.SysMemSlicePitch = 0;
	
    HRESULT hr = m_dx11_core->pd3dDevice->CreateBuffer( &bd, NULL, &m_pVertexBuffer );
    if( FAILED( hr ) )
        return;
	
	//obt@̃Zbg.	
    // CX^Xvertex buffer
//    UINT stride = sizeof( vec3f );
  //  m_dx11_core->pd3dDC->IASetVertexBuffers( 1, 1, &m_pInstanceBuffer, &stride, &offset );

	m_vertex_max_count = count;

	if(m_pOldBuffer) m_pOldBuffer->Release();


}
*/