
#ifndef GL_BGR
#define GL_BGR 0x80E0
#endif


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "ai_funcs.h"
#include "MDLoader.h"
//#include "AtomRendererGL.h"
#include "windib2.h"
#include "debugprint.h"

#pragma warning(disable : 4996)


//extern int visibleMode;
//extern AtomRendererGL* renderer;
extern int g_visual_box;


void AI_setSphere(GLdouble radius, GLint slices, GLint stacks){
	
	int i, k;
	double daXY = 2.0*PI/double(slices);
	double daZX = PI/double(stacks);
	double angleZX;
	double angleXY;
	double *cosZX, *sinZX;
	double cosXY, sinXY;
	double ex, ey;
	double *bfrex, *bfrey;
	

	
	cosZX = new double[stacks - 1];
	sinZX = new double[stacks - 1];
	bfrex = new double[stacks - 1];
	bfrey = new double[stacks - 1];

	angleZX = daZX;
	for (i = 0; i < stacks - 1; i++){
		cosZX[i] = cos(angleZX);
		bfrex[i] = sinZX[i] = sin(angleZX);
		bfrey[i] = 0.0;
		angleZX += daZX;
		
	}


	angleXY = daXY;

	for (k = 0; k < slices; k++) {
		cosXY = cos(angleXY);
		sinXY = sin(angleXY);


		glBegin(GL_TRIANGLE_STRIP); 
			
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(0.0f,0.0f,(float)radius);
		
		
		for (i = 0; i < stacks - 1; i++) {
			ex = sinZX[i] * cosXY;
			ey = sinZX[i] * sinXY;

			glNormal3f((float)bfrex[i], (float)bfrey[i], (float)cosZX[i]);
			glVertex3f((float)(radius * bfrex[i]), (float)(radius * bfrey[i]), (float)(radius * cosZX[i]));
			
			glNormal3f((float)ex, (float)ey , (float)cosZX[i]);
			glVertex3f((float)(radius * ex), (float)(radius * ey) , (float)(radius * cosZX[i]));
			bfrex[i] = ex;
			bfrey[i] = ey;
		}

		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(0.0f,0.0f,(float)(-radius));
		
		glEnd();
		
		angleXY += daXY;

	}
	
	delete [] cosZX;
	delete [] sinZX;
	delete [] bfrex;
	delete [] bfrey;

};
/*
void AI_setBackSphere(GLdouble radius, GLint slices, GLint stacks){
	
	int i, k;
	double daXY = 2.0*PI/double(slices);
	double daZX = PI/double(stacks);
	double angleZX;
	double angleXY;
	double *cosZX, *sinZX;
	double cosXY, sinXY;
	double ex, ey;
	double *bfrex, *bfrey;
	

	
	cosZX = new double[stacks - 1];
	sinZX = new double[stacks - 1];
	bfrex = new double[stacks - 1];
	bfrey = new double[stacks - 1];

	angleZX = daZX;
	for (i = 0; i < stacks - 1; i++){
		cosZX[i] = cos(angleZX);
		bfrex[i] = sinZX[i] = sin(angleZX);
		bfrey[i] = 0.0;
		angleZX += daZX;
		
	}


	angleXY = daXY;

	for (k = 0; k < slices; k++) {
		cosXY = cos(angleXY);
		sinXY = sin(angleXY);


		glBegin(GL_TRIANGLE_STRIP); 
			
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(0.0f,0.0f,(float)radius);
		
		
		for (i = 0; i < stacks - 1; i++) {
			ex = sinZX[i] * cosXY;
			ey = sinZX[i] * sinXY;

			glNormal3f((float)(-ex), (float)(-ey) , (float)(-cosZX[i]));
			glVertex3f((float)(radius * ex), (float)(radius * ey) , (float)(radius * cosZX[i]));
			glNormal3f((float)(-bfrex[i]), (float)(-bfrey[i]), (float)(-cosZX[i]));
			glVertex3f((float)(radius * bfrex[i]), (float)(radius * bfrey[i]), (float)(radius * cosZX[i]));
			
			bfrex[i] = ex;
			bfrey[i] = ey;
		}

		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(0.0f,0.0f,(float)(-radius));
		
		glEnd();
		
		angleXY += daXY;

	}
	
	delete [] cosZX;
	delete [] sinZX;
	delete [] bfrex;
	delete [] bfrey;

};


void AI_setBond(GLfloat r, GLint stacks,
				 GLfloat xi, GLfloat yi, GLfloat zi,
				 GLfloat xf, GLfloat yf, GLfloat zf,
				 GLfloat* color1, GLfloat* color2){
	
	GLint i;
	double da = 2.0*PI/double(stacks);
	double angle = 0.0;
	double cosk,sink;
	GLfloat xx;
	GLfloat ex,ey,ez;
	GLfloat tx,ty,tz;
	GLfloat lx,ly,lz;
	//GLfloat *kx,*ky,*kz;
	GLfloat kx,ky,kz;


	ex = xf-xi;
	ey = yf-yi;
	ez = zf-zi;
	xx = ex*ex + ey*ey + ez*ez;
	xx = (float)sqrt(xx);
	ex = ex /xx;
	ey = ey /xx;
	ez = ez /xx;

	if (fabs(ez) < 0.7){
		lx = ey;
		ly = - ex;
		lz = 0.0;
		xx = lx*lx + ly*ly;
		xx = (float)sqrt(xx);
		lx = lx /xx;
		ly = ly /xx;
		//lz = lz /xx;
		
		tx = ly*ez;
		ty = -lx*ez;
		tz = lx*ey-ly*ex;

	}else{
		ly = ez;
		lz = - ey;
		lx = 0.0;
		xx = ly*ly + lz*lz;
		xx = (float)sqrt(xx);
		//lx = lx /xx;
		ly = ly /xx;
		lz = lz /xx;
		
		tx = ly*ez-lz*ey;
		ty = lz*ex;
		tz = -ly*ex;
	}

	ex = (xi + xf) * 0.5f;
	ey = (yi + yf) * 0.5f;
	ez = (zi + zf) * 0.5f;

	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,color1);
	glBegin(GL_TRIANGLE_STRIP); 
	//GL_TRIANGLE_STRIPg
	//		Ԗڂ̎Op``钸_̔ԍA
	//		ԖڂƔׂĕ\̏ɂȂ邪A
	//		Liblaryŕ\悤ɎCĂB
	//		Ԗڂ̎Op`̒_ԍ\ɂȂ悤ɑB
	
	for (i = 0; i < stacks; i++) {
		cosk = r * cos(angle);
		sink = r * sin(angle);
		kx = (float)(tx * cosk + lx * sink);
		ky = (float)(ty * cosk + ly * sink);
		kz = (float)(tz * cosk + lz * sink);
		glNormal3f(kx,ky,kz);
		glVertex3f(kx + ex,ky + ey,kz + ez);
		//glNormal3f(kx,ky,kz);
		glVertex3f(kx + xi,ky + yi,kz + zi);
		
		angle += da;
		
		
	}
		kx = r * tx;
		ky = r * ty;
		kz = r * tz;
		glNormal3f(kx,ky,kz);
		glVertex3f(kx + ex,ky + ey,kz + ez);
		//glNormal3f(kx,ky,kz);
		glVertex3f(kx + xi,ky + yi,kz + zi);
		
	glEnd();
	
	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,color2);
	glBegin(GL_TRIANGLE_STRIP); 
	//GL_TRIANGLE_STRIPg
	//		Ԗڂ̎Op``钸_̔ԍA
	//		ԖڂƔׂĕ\̏ɂȂ邪A
	//		Liblaryŕ\悤ɎCĂB
	//		Ԗڂ̎Op`̒_ԍ\ɂȂ悤ɑB
	
	for (i = 0; i < stacks; i++) {
		cosk = r * cos(angle);
		sink = r * sin(angle);
		kx = (float)(tx * cosk + lx * sink);
		ky = (float)(ty * cosk + ly * sink);
		kz = (float)(tz * cosk + lz * sink);
		glNormal3f(kx,ky,kz);
		glVertex3f(kx + xf,ky + yf,kz + zf);
		//glNormal3f(kx,ky,kz);
		glVertex3f(kx + ex,ky + ey,kz + ez);
		
		angle += da;
		
		
	}
		kx = r * tx;
		ky = r * ty;
		kz = r * tz;
		glNormal3f(kx,ky,kz);
		glVertex3f(kx + xf,ky + yf,kz + zf);
		//glNormal3f(kx,ky,kz);
		glVertex3f(kx + ex,ky + ey,kz + ez);
		
	glEnd();

}


void AI_setCylinder(GLfloat r, GLint slices, GLint stacks,
				 GLfloat xi, GLfloat yi, GLfloat zi,
				 GLfloat xf, GLfloat yf, GLfloat zf){
	
	GLint i;
	double da = 2.0*PI/double(stacks);
	double angle = 0.0;
	double cosk,sink;
	GLfloat xx;
	GLfloat ex,ey,ez;
	GLfloat tx,ty,tz;
	GLfloat lx,ly,lz;
	//GLfloat *kx,*ky,*kz;
	GLfloat kx,ky,kz;


	ex = xf-xi;
	ey = yf-yi;
	ez = zf-zi;
	xx = ex*ex + ey*ey + ez*ez;
	xx = (float)sqrt(xx);
	ex = ex /xx;
	ey = ey /xx;
	ez = ez /xx;

	if (fabs(ez) < 0.7){
		lx = ey;
		ly = - ex;
		lz = 0.0;
		xx = lx*lx + ly*ly;
		xx = (float)sqrt(xx);
		lx = lx /xx;
		ly = ly /xx;
		//lz = lz /xx;
		
		tx = ly*ez;
		ty = -lx*ez;
		tz = lx*ey-ly*ex;

	}else{
		ly = ez;
		lz = - ey;
		lx = 0.0;
		xx = ly*ly + lz*lz;
		xx = (float)sqrt(xx);
		//lx = lx /xx;
		ly = ly /xx;
		lz = lz /xx;
		
		tx = ly*ez-lz*ey;
		ty = lz*ex;
		tz = -ly*ex;
	}

	glBegin(GL_TRIANGLE_STRIP); 
	//GL_TRIANGLE_STRIPg
	//		Ԗڂ̎Op``钸_̔ԍA
	//		ԖڂƔׂĕ\̏ɂȂ邪A
	//		Liblaryŕ\悤ɎCĂB
	//		Ԗڂ̎Op`̒_ԍ\ɂȂ悤ɑB
	
	for (i = 0; i < stacks; i++) {
		cosk = r * cos(angle);
		sink = r * sin(angle);
		kx = (float)(tx * cosk + lx * sink);
		ky = (float)(ty * cosk + ly * sink);
		kz = (float)(tz * cosk + lz * sink);
		glNormal3f(kx,ky,kz);
		glVertex3f(kx + xf,ky + yf,kz + zf);
		//glNormal3f(kx,ky,kz);
		glVertex3f(kx + xi,ky + yi,kz + zi);
		
		angle += da;
		
		
	}
		kx = r * tx;
		ky = r * ty;
		kz = r * tz;
		glNormal3f(kx,ky,kz);
		glVertex3f(kx + xf,ky + yf,kz + zf);
		//glNormal3f(kx,ky,kz);
		glVertex3f(kx + xi,ky + yi,kz + zi);
		
	glEnd();

}

void AI_setArrow(GLfloat r, GLint slices, GLint stacks,
				 GLfloat xi, GLfloat yi, GLfloat zi,
				 GLfloat xf, GLfloat yf, GLfloat zf){
	
	GLint i;
	double da = 2.0*PI/double(stacks);
	double angle = 0.0;
	double cosk,sink;
	GLfloat xx;
	GLfloat ex,ey,ez;
	GLfloat tx,ty,tz;
	GLfloat lx,ly,lz;
	GLfloat xm,ym,zm;
	GLfloat footlen = 0.6f;
	GLfloat headmag = 3.0f;
	GLfloat kx[32],ky[32],kz[32];
	GLfloat nx[32],ny[32],nz[32];

	ex = xf-xi;
	ey = yf-yi;
	ez = zf-zi;
	xm = xi + ex * footlen;
	ym = yi + ey * footlen;
	zm = zi + ez * footlen;
	xx = ex*ex + ey*ey + ez*ez;
	xx = (float)sqrt(xx);
	ex = ex /xx;
	ey = ey /xx;
	ez = ez /xx;

	if (fabs(ez) < 0.7){
		lx = ey;
		ly = - ex;
		lz = 0.0;
		xx = lx*lx + ly*ly;
		xx = (float)sqrt(xx);
		lx = lx /xx;
		ly = ly /xx;
		//lz = lz /xx;
		
		tx = ly*ez;
		ty = -lx*ez;
		tz = lx*ey-ly*ex;

	}else{
		ly = ez;
		lz = - ey;
		lx = 0.0;
		xx = ly*ly + lz*lz;
		xx = (float)sqrt(xx);
		//lx = lx /xx;
		ly = ly /xx;
		lz = lz /xx;
		
		tx = ly*ez-lz*ey;
		ty = lz*ex;
		tz = -ly*ex;
	}

	for (i = 0; i < stacks; i++) {
		cosk = r * cos(angle);
		sink = r * sin(angle);
		nx[i] = (float)(tx * cosk + lx * sink);
		ny[i] = (float)(ty * cosk + ly * sink);
		nz[i] = (float)(tz * cosk + lz * sink);
		kx[i + stacks*2] = nx[i] * headmag + xm;
		ky[i + stacks*2] = ny[i] * headmag + ym;
		kz[i + stacks*2] = nz[i] * headmag + zm;
		kx[i + stacks] = nx[i] + xm;
		ky[i + stacks] = ny[i] + ym;
		kz[i + stacks] = nz[i] + zm;
		kx[i] = nx[i] + xi;
		ky[i] = ny[i] + yi;
		kz[i] = nz[i] + zi;

		angle += da;
		
	}

	//glColor3f(0.0, 0.0, 1.0);
	glBegin(GL_TRIANGLE_FAN); 
		//GL_TRIANGLE_STRIPg
		//	Ԗڂ̎Op``钸_̔ԍA
		//	ԖڂƔׂĕ\̏ɂȂ邪A
		//	Liblaryŕ\悤ɎCĂB
		//	Ԗڂ̎Op`̒_ԍ\ɂȂ悤ɑB
	glNormal3f(ex, ey, ez);
	glVertex3f(xf, yf, zf);
	for (i = stacks*2; i < stacks*3; i++) {
		glNormal3f(nx[i],ny[i],nz[i]);
		glVertex3f(kx[i],ky[i],kz[i]);
	}
		glNormal3f(nx[stacks*2],ny[stacks*2],nz[stacks*2]);
		glVertex3f(kx[stacks*2],ky[stacks*2],kz[stacks*2]);
	glEnd();
	
	glBegin(GL_TRIANGLE_STRIP); 
		//GL_TRIANGLE_STRIPg
		//	Ԗڂ̎Op``钸_̔ԍA
		//	ԖڂƔׂĕ\̏ɂȂ邪A
		//	Liblaryŕ\悤ɎCĂB
		//	Ԗڂ̎Op`̒_ԍ\ɂȂ悤ɑB

	for (i = 0; i < stacks; i++) {
		
		glNormal3f(nx[i+stacks],ny[i+stacks],nz[i+stacks]);
		glVertex3f(kx[i+stacks],ky[i+stacks],kz[i+stacks]);
		//glNormal3f(nx[i],ny[i],nz[i]);
		glVertex3f(kx[i],ky[i],kz[i]);
	}
		glNormal3f(nx[stacks],ny[stacks],nz[stacks]);
		glVertex3f(kx[stacks],ky[stacks],kz[stacks]);
		//glNormal3f(nx[0],ny[0],nz[0]);
		glVertex3f(kx[0],ky[0],kz[0]);
	glEnd();

}
*/

void AI_setBoundary(float x1, float y1, float z1, float x2, float y2, float z2){
	float clr[] = {1.0, 1.0, 1.0,1.0};
	
	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,clr);


	glBegin(GL_LINE_LOOP);
		glVertex3f(x1, y2, z1);
		glVertex3f(x1, y1, z1);
		glVertex3f(x1, y1, z2);
		glVertex3f(x1, y2, z2);
	glEnd();

	glBegin(GL_LINE_LOOP);
		glVertex3f(x1, y1, z1);
		glVertex3f(x2, y1, z1);
		glVertex3f(x2, y1, z2);
		glVertex3f(x1, y1, z2);
	glEnd();
	
	
	glBegin(GL_LINE_LOOP);
		glVertex3f(x2, y1, z1);
		glVertex3f(x2, y2, z1);
		glVertex3f(x2, y2, z2);
		glVertex3f(x2, y1, z2);
	glEnd();
	
	
	glBegin(GL_LINE_LOOP);
		glVertex3f(x2, y2, z1);
		glVertex3f(x1, y2, z1);
		glVertex3f(x1, y2, z2);
		glVertex3f(x2, y2, z2);
	glEnd();
	
	
}

void AI_setSimBox(mat33f* axis, vec3f* org){
	float clr[] = {1.0, 1.0, 1.0,1.0};
	
	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,clr);

	vec3f pos;

	glBegin(GL_LINE_LOOP);
		pos = *org + axis->b; 
		glVertex3fv((float*)&pos);//(x1, y2, z1);
		pos = *org; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->c; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->b + axis->c; 
		glVertex3fv((float*)&pos);
	glEnd();

	glBegin(GL_LINE_LOOP);
		pos = *org; 
		glVertex3fv((float*)&pos);//(x1, y2, z1);
		pos = *org + axis->a; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->a + axis->c; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->c; 
		glVertex3fv((float*)&pos);
	glEnd();
	
	
	glBegin(GL_LINE_LOOP);
		pos = *org + axis->a; 
		glVertex3fv((float*)&pos);//(x1, y2, z1);
		pos = *org + axis->a + axis->b; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->a + axis->b + axis->c; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->a + axis->c; 
		glVertex3fv((float*)&pos);
	glEnd();
	
	
	glBegin(GL_LINE_LOOP);
		pos = *org + axis->a + axis->b; 
		glVertex3fv((float*)&pos);//(x1, y2, z1);
		pos = *org + axis->b; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->b + axis->c; 
		glVertex3fv((float*)&pos);
		pos = *org + axis->a + axis->b + axis->c;
		glVertex3fv((float*)&pos);
	glEnd();
	
	
}

void AI_getBMfromGL(const TCHAR *fName, GLenum mode){
	int size_Line;
	int size_Color = 3;
	BYTE *bmBuf;	
	FILE *fp;
	//BITMAPINFOHEADER bmih;
	
	GLint viewport[4];//x,y,w,h in viewport.
	
	glGetIntegerv(GL_VIEWPORT,viewport);//get viewport.
	
	glPixelStorei( GL_PACK_ALIGNMENT, 4);
		/*f[^]4byteɃZbgB32bitƂ̂B
	      ]ȕ0Ŗ߂BDIBdlȂ̂ł傤Ǘǂ*/
	
	//If using double buffer, select source to read pixels.
	//By default, mode is GL_FRONT in single-buffered configurations,
	//and GL_BACK in double-buffered configurations.
	glReadBuffer(mode);

	size_Line = viewport[2] * size_Color;
	if (size_Line % 4){	size_Line += 4 - (size_Line % 4);}
	
	bmBuf = new BYTE[size_Line * viewport[3]];

	glReadPixels(
        viewport[0], viewport[1],               // Jn_
        viewport[2], viewport[3],                // ǂݎTCY
        GL_BGR,             // ǂݎ`ݒ(verႢƓȂ)
        GL_UNSIGNED_BYTE,                  // ۑ̃|C^̌^ 
        bmBuf                 // ۑ̔z̃|C^
	);
	
	fp = _tfopen(fName,_T("wb"));
	if (!fp){
		printf("bmpt@C̍쐬Ɏs܂\n");
		return;
	}
	
	//BYTE* dibBuf = CreateDIBfromRGB(bmBuf, viewport[2], viewport[3], &bmih);
	//writeDIB(fp, &bmih, dibBuf);
	//delete [] dibBuf;
	
	//convRGBtoDIB(viewport[2], viewport[3], bmBuf);
	writeDIB24(fp, viewport[2], viewport[3], bmBuf);

	delete [] bmBuf;
	fclose(fp);
}


//݂̉摜𐔔{TCYŏo
void AI_getBMfromGLMag(ATOMS_DATA* dat, AtomRendererGL* renderer, const TCHAR *fName, int magnify){
	
	int size_Color = 3;	
	FILE *fp;
	//BITMAPINFOHEADER bmih;
	
	GLint viewport[4];//x,y,w,h in viewport.
	
	fp = _tfopen(fName,_T("wb"));
	if (!fp){
		printf("bmpt@C̍쐬Ɏs܂\n");
		return;
	}
	

	glGetIntegerv(GL_VIEWPORT,viewport);//get viewport.
	
	glPixelStorei( GL_PACK_ALIGNMENT, 4);
		/*f[^]4byteɃZbgB32bitƂ̂B
	      ]ȕ0Ŗ߂BDIBdlȂ̂ł傤Ǘǂ*/
	
	//If using double buffer, select source to read pixels.
	//By default, mode is GL_FRONT in single-buffered configurations,
	//and GL_BACK in double-buffered configurations.
	glReadBuffer(GL_BACK);

	int line_size = viewport[2] * size_Color;
	if (line_size % 4){	line_size += 4 - (line_size % 4);}
	BYTE *bmBuf = new BYTE[line_size * viewport[3]];

	int all_line_size = viewport[2] * size_Color * magnify;
	if (all_line_size % 4){	all_line_size += 4 - (all_line_size % 4);}
	BYTE *allBuf = new BYTE[all_line_size * viewport[3] * magnify];
	
	double ss = tan(20.0 * PI / (180.0 * 2.0));
	double top = ss * 10.0;
	double right = top * (double)viewport[2] / (double)viewport[3];

	double dh = top * 2.0 / (double)magnify;
	double dw = right * 2.0 / (double)magnify;

	glLineWidth((float)magnify);

	
	int x, y;
	int offset_y = 0;
	double btm = -top;

	for (y = 0; y < magnify; y++){
		int offset_x = 0;
		double left = - right;
		for (x = 0; x < magnify; x++){


			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();		
			
			glFrustum(left, left + dw, btm, btm + dh, 10.0,2000.0);


			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			
			GLfloat lva[] = {0.4f, 0.4f, 0.4f,1.0f};
			GLfloat lvp[] = {0.0f, 0.0f, 10.0f,0.0f};
			//Cg̐ݒ
			glLightfv(GL_LIGHT0, GL_AMBIENT, lva);
			glLightfv(GL_LIGHT0, GL_POSITION, lvp);
				//GL_POSITION̑4p[^0͕̎s,0ȊOł͓_

			glMatrixMode(GL_MODELVIEW);

			//ATOMS_DATA *dat = atm->GetDataPointer();
			//AI_drawAtoms(dat, visibleMode, atm->Jmax);
			renderer->Rendering(dat);
			if(g_visual_box){
				
				//AI_setBoundary(-dat->boxx*0.5f, -dat->boxy*0.5f, -dat->boxz*0.5f, dat->boxx*0.5f, dat->boxy*0.5f, dat->boxz*0.5f);
				AI_setSimBox(&(dat->boxaxis), &(dat->boxorg));
			}
			glFlush();

			glReadPixels(
				viewport[0], viewport[1],               // Jn_
				viewport[2], viewport[3],                // ǂݎTCY
				GL_BGR,             // ǂݎ`ݒ(verႢƓȂ)
				GL_UNSIGNED_BYTE,                  // ۑ̃|C^̌^ 
				bmBuf                 // ۑ̔z̃|C^
			);

			int k;
			for(k = 0; k < viewport[3]; k++){
				memcpy(allBuf + offset_y + offset_x + k * all_line_size,
						bmBuf + k * line_size,
						viewport[2] * size_Color);
			}
					
			offset_x += viewport[2] * size_Color;
			left += dw;
		}
		offset_y += all_line_size * viewport[3];
		btm += dh;
	}

	delete [] bmBuf;
	
	writeDIB24(fp, viewport[2] * magnify, viewport[3] * magnify, allBuf);

	
	delete [] allBuf;
	fclose(fp);

	glLineWidth(1.0f);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-right, right, -top, top, 10.0,2000.0);
}



/*
//݂̉摜O{TCYŏo
//eye_length: ڂƖڂ̋, _ỎʉPʒƂĎw
void AI_getBMfromGL3D(const TCHAR *fName, float eye_length){
	

	int size_Color = 3;	
	FILE *fp;
	//BITMAPINFOHEADER bmih;
	
	GLint viewport[4];//x,y,w,h in viewport.
	
	fp = _tfopen(fName,_T("wb"));
	if (!fp){
		printf("bmpt@C̍쐬Ɏs܂\n");
		return;
	}
	

	glGetIntegerv(GL_VIEWPORT,viewport);//get viewport.
	
	glPixelStorei( GL_PACK_ALIGNMENT, 4);
		//f[^]4byteɃZbgB32bitƂ̂B
	    //]ȕ0Ŗ߂BDIBdlȂ̂ł傤Ǘǂ
	
	//If using double buffer, select source to read pixels.
	//By default, mode is GL_FRONT in single-buffered configurations,
	//and GL_BACK in double-buffered configurations.
	glReadBuffer(GL_BACK);

	int line_size = viewport[2] * size_Color;
	if (line_size % 4){	line_size += 4 - (line_size % 4);}
	BYTE *bmBuf = new BYTE[line_size * viewport[3]];

	int all_line_size = viewport[2] * size_Color * magnify;
	if (all_line_size % 4){	all_line_size += 4 - (all_line_size % 4);}
	BYTE *allBuf = new BYTE[all_line_size * viewport[3] * magnify];
	
	double ss = tan(20.0 * PI / (180.0 * 2.0));
	double top = ss * 10.0;
	double right = top * (double) viewport[2] / (double)viewport[3];
	double eyelen2 = eye_length * right;
	
	int x, y;
	int offset_y = 0;
	double btm = -top;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();		
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			
			GLfloat lva[] = {0.4f, 0.4f, 0.4f,1.0f};
			GLfloat lvp[] = {0.0f, 0.0f, 10.0f,0.0f};
			//Cg̐ݒ
			glLightfv(GL_LIGHT0, GL_AMBIENT, lva);
			glLightfv(GL_LIGHT0, GL_POSITION, lvp);
				//GL_POSITION̑4p[^0͕̎s,0ȊOł͓_

			
			glFrustum(-right-eyelen2, right - eyelen2, -top, top, 10.0,2000.0);
		
			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
			
			cam_info.focus_y -= eyelen2 * cos(cam_info.aglxy);
			cam_info.focus_x += eyelen2 * sin(cam_info.aglxy);
			AI_setCamera( &cam_info );

			ATOMS_DATA *dat = atm->GetDataPointer();
			AI_drawAtoms(atm->GetDataPointer(), 3, atm->Jmax);
			if(color_idx == 1){
				AI_drawAtomOutline(dat);
			}
			if(g_visual_box){
				AI_setBoundary(-dat->boxx*0.5f, -dat->boxy*0.5f, -dat->boxz*0.5f, dat->boxx*0.5f, dat->boxy*0.5f, dat->boxz*0.5f);
			}
			glFlush();

			glReadPixels(
				viewport[0], viewport[1],               // Jn_
				viewport[2], viewport[3],                // ǂݎTCY
				GL_BGR,             // ǂݎ`ݒ(verႢƓȂ)
				GL_UNSIGNED_BYTE,                  // ۑ̃|C^̌^ 
				bmBuf                 // ۑ̔z̃|C^
			);

			int k;
			for(k = 0; k < viewport[3]; k++){
				memcpy(allBuf + offset_y + offset_x + k * all_line_size,
						bmBuf + k * line_size,
						viewport[2] * size_Color);
			}
					
			offset_x += viewport[2] * size_Color;
			left += dw;
		}
		offset_y += all_line_size * viewport[3];
		btm += dh;
	}

	delete [] bmBuf;
	
	writeDIB24(fp, viewport[2] * magnify, viewport[3] * magnify, allBuf);

	
	delete [] allBuf;
	fclose(fp);

	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-right, right, -top, top, 10.0,2000.0);
}
*/

/*
//p~
void AI_setCamera(CAMERA_INFO* cam_info){
	double cosxy = cos(cam_info->aglxy);
	double sinxy = sin(cam_info->aglxy);
	double cosz = cos(cam_info->aglz);
	double sinz = sin(cam_info->aglz);
	
	glLoadIdentity();
	gluLookAt(cam_info->radius*sinz*cosxy + cam_info->focus_x,
			cam_info->radius*sinz*sinxy + cam_info->focus_y,
			cam_info->radius*cosz + cam_info->focus_z,
			cam_info->focus_x, cam_info->focus_y, cam_info->focus_z,
			-cam_info->radius*cosz*cosxy,
			-cam_info->radius*cosz*sinxy,
			cam_info->radius*sinz );
}
*/


float AI_GetDepth(int x, int y){
	float depth;
	GLint viewport[4];//x,y,w,h in viewport.
	
	glGetIntegerv(GL_VIEWPORT,viewport);//get viewport.
	glReadPixels(x, viewport[3]-y, 1, 1,
               GL_DEPTH_COMPONENT,
               GL_FLOAT,
               &depth);
	
	return depth;

}

void  AI_GetWorldXYZ(int x, int y, double depth, 
            double &wx, double &wy,double &wz){
       
	// Matrix (4*4) for modelview and projection.
	GLdouble modelviewM[16],projectionM[16];
	// viewport
	GLint viewport[4];
	// get modelview, projection and viewport.
	glGetDoublev(GL_MODELVIEW_MATRIX, modelviewM);
	glGetDoublev(GL_PROJECTION_MATRIX, projectionM);
	glGetIntegerv(GL_VIEWPORT, viewport);
	//get world coordinate.
	gluUnProject((double)x, (double)(viewport[3]-y), depth,
               modelviewM, projectionM, viewport,
               &wx, &wy, &wz);

 }


/*
void AI_DrawString(void *font, const char* msgstr){
	int cnt = strlen(msgstr);
	int i;

	for(i=0;i<cnt;i++){
		glutBitmapCharacter(font, msgstr[i]);
	}

}


int AI_WidthString(void *font, const char* msgstr){
	int cnt = strlen(msgstr);
	int i;
	int ret = 0;

	for(i=0;i<cnt;i++){
		ret += glutBitmapWidth(font, msgstr[i]);
	}
	return ret;
}
*/

void AI_RasterDot(int x, int y, int wndw, int wndh){
	//X^[ʒuhbg(sNZ)Ŏw
	double fx, fy;
	
	fx = ((double)x) / ((double)wndw) * 2.0 - 1.0;
	fy = -((double)y) / ((double)wndh) * 2.0 + 1.0;
	
	glRasterPos2d(fx,fy);
	
}


void AI_Begin2DMode(int width, int height){
		//GL_PROJECTIONGL_MODELVIEW̍sX^bN͓Ɨ
		//ČXPushKv

		//
			
		glDisable(GL_LIGHTING);		//XvCgeNX`Fǂɕ\邽
		glDisable(GL_DEPTH_TEST);	//dȂ߃XvCg𐳂\邽
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glLoadIdentity();
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
		glOrtho(0.0f, (float)width, (float)height, 0.0f, 1.0f,-1.0f);

}

void AI_End2DMode(){
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();
		
		glEnable(GL_LIGHTING);
		glEnable(GL_DEPTH_TEST);
}



