#ifndef __ai_funcs_h__
#define __ai_funcs_h__

#include "sdkwgl.h"
#include <tchar.h>
#include "AtomRendererGL.h"


const double ATOM_RADIUS = 0.25;
const double ATOM_RADIUS_LARGE = 1.0;

void AI_setSphere(GLdouble radius, GLint slices, GLint stacks);

void AI_setBoundary(float x1, float y1, float z1, float x2, float y2, float z2);
void AI_setSimBox(mat33f* axis, vec3f* org);
void AI_getBMfromGL(const TCHAR *fName, GLenum mode);
void AI_getBMfromGLMag(ATOMS_DATA* dat, AtomRendererGL* renderer, const TCHAR *fName, int magnify);	//ʏ̎O{
void AI_getBMfromGL3D(const TCHAR *fName, int magnify);	//̎
int AI_readPDB(const TCHAR *fR,ATOMS_DATA **fst);
//void AI_setCamera(CAMERA_INFO* cam_info);
float AI_GetDepth(int x, int y);
void  AI_GetWorldXYZ(int x, int y, double depth, double &wx, double &wy,double &wz);
//int AI_readBIN(const char *fR,ATOMS_DATA **fst);
//int AI_readMD(const char *fR,ATOMS_DATA **fst);
void AI_DrawString(void *font, const TCHAR* msgstr);
int AI_WidthString(void *font, const TCHAR* msgstr);
//void AI_RasterDot(int x, int y, int wndw, int wndh);
void AI_Begin2DMode(int width, int height);
void AI_End2DMode();


#endif    // __ai_funcs_h__