
#ifndef __ai_molecule_h__
#define __ai_molecule_h__

#include "MDLoader.h"

//q\
	struct MolType{
		int Cn;
		int Hn;
		int Xn;
		int count;
		MolType* next;
	};

int* AI_CreateMolList(ATOMS_DATA *dat);
int AI_WriteClassifyMolecule(ATOMS_DATA *dat, const TCHAR* filename);
int AI_nearestAtom(ATOMS_DATA *dat, float x, float y, float z, float limit_r);
int AI_WriteAdsorbedH(MDLoader* a_atm, int frameskip, const TCHAR* filename);

MolType* CreateMolType(ATOMS_DATA *dat);
void DeleteMolType(MolType* moltype_fst);

void AI_ResetBond(ATOMS_DATA *dat);
void AI_eraceBulk(ATOMS_DATA *dat, float limit_z);
void AI_eraceUpper(ATOMS_DATA *dat, float limit_z);

void WriteAdsH(MDLoader* a_atm, int frameskip, const TCHAR* spath);

double fperiodic(double a, double size);
float fperiodic(float a, float size);

#endif    // __ai_molecule_h__
