#include <stdio.h>
#include <string.h>
#include "atomarray.h"



AtomArray::AtomArray(){
	m_buffersize = 0;
	this->count = 0;
	this->knd = NULL;
	this->id = NULL;
	this->mass = NULL;
	this->r = NULL;
	this->p = NULL;
	this->f = NULL;

	
};
	
AtomArray::AtomArray(int buffersize){
	m_buffersize = buffersize;
	this->count = 0;
	this->knd = new int[buffersize];
	this->id = new int[buffersize];
	this->mass = new double [buffersize];
	this->r = new vec3d[buffersize];
	memset(this->r, 0, buffersize * sizeof(vec3d));
	this->p = new vec3d[buffersize];
	memset(this->p, 0, buffersize * sizeof(vec3d));
	this->f = new vec3d[buffersize];
	memset(this->f, 0, buffersize * sizeof(vec3d));
	this->pot = new double[buffersize];
	memset(this->pot, 0, buffersize * sizeof(double));
	
};
	
AtomArray::~AtomArray(){
	Clear();
}



void AtomArray::Clear(){
	this->count = 0;
	delete [] this->knd;
	this->knd = NULL;
	delete [] this->id;
	this->id = NULL;
	delete [] this->mass;
	this->mass = NULL;
	delete [] this->r;
	this->r = NULL;
	delete [] this->p;
	this->p = NULL;
	delete [] this->f;
	this->f = NULL;
	delete [] this->pot;
	this->pot = NULL;

}

void AtomArray::ForceClear(){
	memset(this->f, 0, (this->count) * sizeof(vec3d));
	memset(this->pot, 0, (this->count) * sizeof(double));
}


void AtomArray::CopyAtom(int indexDst, int indexSrc){

	this->knd[indexDst] = this->knd[indexSrc];
	this->mass[indexDst] = this->mass[indexSrc];
	this->id[indexDst] = this->id[indexSrc];
	
	this->r[indexDst] = this->r[indexSrc];
	this->p[indexDst] = this->p[indexSrc];
	this->f[indexDst] = this->f[indexSrc];
	this->pot[indexDst] = this->pot[indexSrc];
	
}

