#include "camera.h"

#pragma warning(disable : 4996)


CameraGL::CameraGL(){
	m_target.x = 0.f;
	m_target.y = 0.f;
	m_target.z = 0.f;
	m_camera.x = 0.f;
	m_camera.y = -50.f;
	m_camera.z = 0.f;
	m_up.x = 0.f;
	m_up.y = 0.f;
	m_up.z = 1.f;

//`FbN|Cg@\	
	m_chkpoint_fst = NULL;
	m_chkpoint_current = NULL;

}


CameraGL::~CameraGL(){
}



void CameraGL::SetGLCamera(){
	
	glLoadIdentity();
	gluLookAt(m_camera.x, m_camera.y, m_camera.z,
			m_target.x, m_target.y, m_target.z,
			m_up.x, m_up.y, m_up.z);

			
}


//a𒆐SɁAxNgv]
void CameraGL::RotateOnAxis(vec3d* a, vec3d* v, double rad){
	
	
	double cos_rad = cos(rad);
	double sin_rad = sin(rad);
	double one_cos = 1.0 - cos_rad;
	double sin_ax = sin_rad * a->x;
	double sin_ay = sin_rad * a->y;
	double sin_az = sin_rad * a->z;

//]s񐶐
	double m[9];
	m[0] = cos_rad + one_cos * a->x * a->x;
	m[3] = m[1] = one_cos * a->x * a->y;
	m[6] = m[2] = one_cos * a->z * a->x;
	m[7] = m[5] = one_cos * a->y * a->z;
	m[4] = cos_rad + one_cos * a->y * a->y;
	m[8] = cos_rad + one_cos * a->z * a->z;

	m[1] -= sin_az;
	m[2] += sin_ay;
	m[3] += sin_az;
	m[5] -= sin_ax;
	m[6] -= sin_ay;
	m[7] += sin_ax;
	
	vec3d v_org = *v;
	v->x = m[0] * v_org.x + m[1] * v_org.y + m[2] * v_org.z;
	v->y = m[3] * v_org.x + m[4] * v_org.y + m[5] * v_org.z;
	v->z = m[6] * v_org.x + m[7] * v_org.y + m[8] * v_org.z;
	
			
}


void CameraGL::OuterProd(vec3d* u, vec3d* v, vec3d* a){
	a->x = u->y * v->z - u->z * v->y;
	a->y = u->z * v->x - u->x * v->z;
	a->z = u->x * v->y - u->y * v->x;
}

//J̏ƕsȃ^[Qbg_̎𒆐Sɉ]
void CameraGL::RotatePosOnUpAxis(double rad){
	vec3d v;
	v.x = m_camera.x - m_target.x;
	v.y = m_camera.y - m_target.y;
	v.z = m_camera.z - m_target.z;
	
	RotateOnAxis(&m_up, &v, rad);
	
	m_camera.x = v.x + m_target.x;
	m_camera.y = v.y + m_target.y;
	m_camera.z = v.z + m_target.z;
	
}

//[hWzS̉]
void CameraGL::RotatePosOnZAxis(double rad){
	vec3d v;
	v.x = m_camera.x - m_target.x;
	v.y = m_camera.y - m_target.y;
	v.z = m_camera.z - m_target.z;
	
	vec3d a;
	a.x = 0.0;
	a.y = 0.0;
	a.z = 1.0;
	
	RotateOnAxis(&a, &v, rad);
	RotateOnAxis(&a, &m_up, rad);
	
	m_camera.x = v.x + m_target.x;
	m_camera.y = v.y + m_target.y;
	m_camera.z = v.z + m_target.z;
	
}

//J̏ւ̉]
void CameraGL::RotatePosToUp(double rad){
	vec3d v;
	v.x = m_camera.x - m_target.x;
	v.y = m_camera.y - m_target.y;
	v.z = m_camera.z - m_target.z;

	vec3d a;
	OuterProd(&m_up, &v, &a);
	//a.x = m_up.y * v.z - m_up.z * v.y;
	//a.y = m_up.z * v.x - m_up.x * v.z;
	//a.z = m_up.x * v.y - m_up.y * v.x;
	double rr = a.x*a.x + a.y*a.y + a.z*a.z;
	rr = 1.0 / sqrt(rr);
	a.x *= rr;
	a.y *= rr;
	a.z *= rr;

	RotateOnAxis(&a, &v, -rad);
	RotateOnAxis(&a, &m_up, -rad);
	
	m_camera.x = v.x + m_target.x;
	m_camera.y = v.y + m_target.y;
	m_camera.z = v.z + m_target.z;
	
}


//J̏ւ̉]
void CameraGL::FocusDown(double r){
	vec3d v;
	v.x = m_camera.x - m_target.x;
	v.y = m_camera.y - m_target.y;
	v.z = m_camera.z - m_target.z;

	double rr = v.x*v.x + v.y*v.y + v.z*v.z;
	rr = sqrt(rr);
	rr = (rr + r) / rr;

	m_camera.x = rr * v.x + m_target.x;
	m_camera.y = rr * v.y + m_target.y;
	m_camera.z = rr * v.z + m_target.z;
	
}


void CameraGL::TargetMoveToZ(double z){
	m_camera.z += z;
	m_target.z += z;
}

//݂Đ^Ɉړ
void CameraGL::TargetMoveToUp(double d){
	
	m_target.x += m_up.x*d;
	m_target.y += m_up.y*d;
	m_target.z += m_up.z*d;
	m_camera.x += m_up.x*d;
	m_camera.y += m_up.y*d;
	m_camera.z += m_up.z*d;

}


//݂Đ^Ɉړ
void CameraGL::TargetMoveToSide(double d){
	vec3d v;
	v.x = m_camera.x - m_target.x;
	v.y = m_camera.y - m_target.y;
	v.z = m_camera.z - m_target.z;
	
	vec3d a;
	OuterProd(&m_up, &v, &a);
	double rr = a.x*a.x + a.y*a.y + a.z*a.z;
	rr = d / sqrt(rr);
	a.x *= rr;
	a.y *= rr;
	a.z *= rr;
	
	m_target += a;
	m_camera += a;

}

//݂đOɈړ
void CameraGL::TargetMoveToFront(double d){
	vec3d v;
	v = m_target - m_camera;
	
	double rr = v.x*v.x + v.y*v.y + v.z*v.z;
	rr = d / sqrt(rr);
	v *= rr;
	
	m_target += v;
	m_camera += v;

}

double CameraGL::GetForcusDistance(){
	vec3d v = m_camera - m_target;
	
	double rr = v * v;
	return sqrt(rr);
}

void CameraGL::SetForcusDistance(double distance){
	vec3d v = m_camera - m_target;
	v = Unit(v);

	m_camera = (v * distance) + m_target;
	
}

//݂Đ^Ɉړ
void CameraGL::SetStereoMode(double ratio){
	if ( ratio <= 1.0){ return;}

	vec3d v;
	v.x = m_camera.x - m_target.x;
	v.y = m_camera.y - m_target.y;
	v.z = m_camera.z - m_target.z;
	
	vec3d a;
	OuterProd(&m_up, &v, &a);
	
	m_target.x = m_camera.x - v.x * ratio;
	m_target.y = m_camera.y - v.y * ratio;
	m_target.z = m_camera.z - v.z * ratio;
	

	v.x = m_camera.x - m_target.x;
	v.y = m_camera.y - m_target.y;
	v.z = m_camera.z - m_target.z;
	OuterProd(&v, &a, &m_up);
	
	double rr = m_up.x*m_up.x + m_up.y*m_up.y + m_up.z*m_up.z;
	rr = 1.0 / sqrt(rr);
	m_up.x *= rr;
	m_up.y *= rr;
	m_up.z *= rr;
	
}


//J݈̌ʒuL
void CameraGL::PushState(){
	
	m_target_mem = m_target;
	m_camera_mem = m_camera;
	m_up_mem = m_up;
}

void CameraGL::PullState(){
	
	m_target = m_target_mem;
	m_camera = m_camera_mem;
	m_up = m_up_mem;
}



//////////////////////////////////////////////////////
//
//    `FbN|Cg@\
//
//////////////////////////////////////////////////////
void CameraGL::DeleteAllCheckPoint(){
	
	CHKPOINT* chkpoint;
	while(m_chkpoint_fst){
		chkpoint = m_chkpoint_fst->next;
		delete m_chkpoint_fst;
		m_chkpoint_fst = chkpoint;
	}	

	//IfstNULLɂȂĂ͂
}


//XgɃ`FbN|Cg}
//overblowɂ͎t[Ƃ̃t[̍ɗ]ɕtĕ\t[LqB
//̂Ƃoverblow͎̃`FbN|Cg𓯂t[ŃJ̌قȂꍇɎgp
//overblow0setƂ͎̃t[Ƃ̍̂܂overblowɂȂ
void CameraGL::InsertCheckPoint(int frame, int overblow){
	
	m_chkpoint_current = new CHKPOINT;
	
	m_chkpoint_current->frame = frame;
	m_chkpoint_current->overblow = overblow;
	m_chkpoint_current->target = m_target;	//|C^ł͂ȂlRs[
	m_chkpoint_current->camera = m_camera;	//|C^ł͂ȂlRs[
	m_chkpoint_current->up = m_up;	//|C^ł͂ȂlRs[


	if(m_chkpoint_fst){
		
		//t[ԍŏɂȂ悤ɑ}
		if(m_chkpoint_fst->frame > frame){
			m_chkpoint_current->next = m_chkpoint_fst;
			m_chkpoint_fst = m_chkpoint_current;
		
		}else{
			CHKPOINT* chkpoint = m_chkpoint_fst;
			while(chkpoint->next){
				if(chkpoint->next->frame > frame){					
					m_chkpoint_current->next = chkpoint->next;
					chkpoint->next = m_chkpoint_current;
					break;
				}
				chkpoint = chkpoint->next;
			}
			if(chkpoint->next == NULL){
				chkpoint->next = m_chkpoint_current;
				m_chkpoint_current->next = NULL;
			}

			if(chkpoint->frame == frame){
				if(chkpoint->overblow == 0){
					chkpoint->overblow = 1;
				}
			}
		}

	}else{
		m_chkpoint_fst = m_chkpoint_current;
		m_chkpoint_current->next = NULL;
	}

	m_playtm = 0;

}


int CameraGL::PlayCheckPoint(int* pframe, int frameskip){

	if(m_chkpoint_current == NULL){ return 0;}
	if(m_chkpoint_current->next == NULL){
		*pframe = m_chkpoint_current->frame;
		m_target = m_chkpoint_current->target;
		m_camera = m_chkpoint_current->camera;
		m_up = m_chkpoint_current->up;
		
		if(m_playtm == 0){
			m_playtm = 1;
			return 1;	//ŏI`FbN|Cg̍Ō̈񂾂͐Ԃ
		}else{
			return 0;	//I0Ԃ
		}
	}

	CHKPOINT* next = m_chkpoint_current->next;
	int overblow = m_chkpoint_current->overblow;
	if(overblow == 0){
		overblow = next->frame - m_chkpoint_current->frame;
	}

	double rate = ((double)m_playtm)/(double)(overblow);
	m_target.x = m_chkpoint_current->target.x
			+ (next->target.x - m_chkpoint_current->target.x) * rate;
	m_target.y = m_chkpoint_current->target.y
			+ (next->target.y - m_chkpoint_current->target.y) * rate;
	m_target.z = m_chkpoint_current->target.z
			+ (next->target.z - m_chkpoint_current->target.z) * rate;

	m_camera.x = m_chkpoint_current->camera.x
			+ (next->camera.x - m_chkpoint_current->camera.x) * rate;
	m_camera.y = m_chkpoint_current->camera.y
			+ (next->camera.y - m_chkpoint_current->camera.y) * rate;
	m_camera.z = m_chkpoint_current->camera.z
			+ (next->camera.z - m_chkpoint_current->camera.z) * rate;

	m_up.x = m_chkpoint_current->up.x
			+ (next->up.x - m_chkpoint_current->up.x) * rate;
	m_up.y = m_chkpoint_current->up.y
			+ (next->up.y - m_chkpoint_current->up.y) * rate;
	m_up.z = m_chkpoint_current->up.z
			+ (next->up.z - m_chkpoint_current->up.z) * rate;

	*pframe = m_chkpoint_current->frame
			+ ((next->frame - m_chkpoint_current->frame) * m_playtm)/overblow;

	m_playtm += frameskip;
	while(m_playtm >= overblow){
		m_playtm -= overblow;
		m_chkpoint_current = m_chkpoint_current->next;
		if(m_chkpoint_current->next==NULL){
			m_playtm = 0;
			break;
		}
		overblow = m_chkpoint_current->overblow;
		if(overblow == 0){
			overblow = m_chkpoint_current->next->frame - m_chkpoint_current->frame;
		}
	}

	return 1;
}

//ŏ܂ŎT߂
void CameraGL::RewindCheckPoint(){

	m_chkpoint_current = m_chkpoint_fst;
	m_playtm = 0;
}


void CameraGL::SaveCheckPoint(const TCHAR* filename){

//t@Co
	FILE* fp = _tfopen(filename,_T("w"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	_ftprintf(fp, _T("#checkpoint for movie ver1.1\n"));
	_ftprintf(fp, _T("#frame, overblew, target_x, _y, _z, camera_x, _y, _z, ")
				_T("up_x, _y, _z\n"));
	
	CHKPOINT* chkpoint = m_chkpoint_fst;
	while(chkpoint){
		_ftprintf(fp, _T("%d\t%d\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n"),
				chkpoint->frame,chkpoint->overblow,
				chkpoint->target.x, chkpoint->target.y, chkpoint->target.z,
				chkpoint->camera.x, chkpoint->camera.y, chkpoint->camera.z,
				chkpoint->up.x, chkpoint->up.y, chkpoint->up.z);

		chkpoint = chkpoint->next;
	}	


	fclose(fp);

}


void CameraGL::LoadCheckPoint(const TCHAR* filename){

//t@Co
	FILE* fp = _tfopen(filename,_T("r"));
	if( fp == NULL ){  // ֐sĂȂ
		printf( "t@C̃I[vɎs܂\n");
		return;  // ُI͂OȊOԂ
	}

	TCHAR chbuf[1024];

	
	
	DeleteAllCheckPoint();
	CHKPOINT* chkpoint;
	
	while(_fgetts(chbuf,1024, fp)){
		
		if(*chbuf == _T('#')){ continue;}

		if(m_chkpoint_fst){
			chkpoint->next = new CHKPOINT;
			chkpoint = chkpoint->next;
		}else{
			chkpoint = m_chkpoint_fst = new CHKPOINT;
		}
		chkpoint->next = NULL;


		_stscanf(chbuf,_T("%d\t%d\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\n"),
				&(chkpoint->frame),&(chkpoint->overblow),
				&(chkpoint->target.x), &(chkpoint->target.y), &(chkpoint->target.z),
				&(chkpoint->camera.x), &(chkpoint->camera.y), &(chkpoint->camera.z),
				&(chkpoint->up.x), &(chkpoint->up.y), &(chkpoint->up.z));

	}


	fclose(fp);

}

