
#include <stdio.h>
#include <string.h>
#include "celldiv.h"
#include "atomarray.h"





//#define IMODULO(x,y)    ( x < 0 ? ((y - 1)-((-x-1) % y)) : (x % y))



CellDiv::CellDiv(double cellwidth, int periodic_flag, int maxcount){


	m_max_count = maxcount;
	
	m_mcell = 0;
	m_mx = 0;
	m_my = 0;
	m_mz = 0;

	m_cell_pair = NULL;
	m_first_in_cell = NULL;
	m_inext = new int[m_max_count];
		

	m_cellwidth = cellwidth;		//Z̏l
	m_periodic_flag = periodic_flag;

//	m_cycle_x = new int [m_max_count];	//Exׂ.
//	m_cycle_y = new int [m_max_count];
//	m_cycle_z = new int [m_max_count];

	m_Am.Clear();
}

CellDiv::~CellDiv(){
	delete [] m_inext;
	delete [] m_cell_pair;
	delete [] m_first_in_cell;

//	delete [] m_cycle_x;
//	delete [] m_cycle_y;
//	delete [] m_cycle_z;
	 
}


void CellDiv::SetCellSize(double cellsize, int periodic_flag){
	m_cellwidth = cellsize;
	m_periodic_flag = periodic_flag;
}

void CellDiv::SetBoxsize(double x, double y, double z){
		
	//local ---------
//		double minw;
		m_box.Set(x, y, z);
		m_boxi.Set(1.0/x, 1.0/y, 1.0/z);				//setting this only
		
		m_Am.Set(m_box.x, 0.0, 0.0, 0.0, m_box.y, 0.0, 0.0, 0.0, m_box.z);
				

		int lx,ly,lz;
		lx = (int)(m_box.x/m_cellwidth);
		ly = (int)(m_box.y/m_cellwidth);
		lz = (int)(m_box.z/m_cellwidth);
		InitCell(lx,ly,lz);
		
}


////͐Ȃǂɂ񒼌̕ӂɂsim.box̐ݒ
void CellDiv::SetBoxAxis(mat33d Am){

	m_Am = Am;

	vec3d v = Cross(Am.b, Am.c);
	double abc = Am.a * v;
	double abs_b_c = Abs(v);
	v = Cross(Am.c, Am.a);
	double abs_c_a = Abs(v);
	v = Cross(Am.a, Am.b);
	double abs_a_b = Abs(v);
	

	//local ---------
		int lx,ly,lz;
		lx = (int)(abc/(m_cellwidth * abs_b_c));
		ly = (int)(abc/(m_cellwidth * abs_c_a));
		lz = (int)(abc/(m_cellwidth * abs_a_b));		
		InitCell(lx,ly,lz);

	m_box.x = Am.a.x;
	m_box.y = Am.b.y;
	m_box.z = Am.c.z;
	m_boxi.x = 1.0/Am.a.x;
	m_boxi.y = 1.0/Am.b.y;
	m_boxi.z = 1.0/Am.c.z;
}

void CellDiv::SetBoxAxis(vec3d a, vec3d b, vec3d c){
		
		mat33d Am;
		Am.a = a;
		Am.b = b;
		Am.c = c;

		SetBoxAxis(Am);
}
/*
mat33d CellDiv::GetBoxAxis(){
	return m_Am;
}
*/

////////////////////////////////////////////////////////
//
//  Tcell̃yA\߃XgAbvĂ֐.
//
//  EłȂꍇ͂ŋEׂcell̃yAȂpɂ.
//  ɂāAREBONXSetList`ł͋EɊւ炸֐g.
//
////////////////////////////////////////////////////////

void CellDiv::InitCell(int a_mcx, int a_mcy, int a_mcz){
		

	int ix,iy,iz ,imap;
	
	if(a_mcx <= 0){ a_mcx = 1;}
	if(a_mcy <= 0){ a_mcy = 1;}
	if(a_mcz <= 0){ a_mcz = 1;}


		
	if(m_mcell != a_mcx * a_mcy * a_mcz){
	//if (g_mcell > 0) {
		delete [] m_cell_pair;
		delete [] m_first_in_cell;
		
		m_mcell = a_mcx*a_mcy*a_mcz;
		m_cell_pair = new int[m_mcell*13*2];
		m_first_in_cell = new int[m_mcell];


		printf("allocate %d, %d, %d)\n",a_mcx,a_mcy,a_mcz);

	}
		
	m_mx = a_mcx;
	m_my = a_mcy;
	m_mz = a_mcz;
	
		
	int dx = 1;
	int dy = m_mx;
	int dz = m_mx*m_my;
	
	int pdx = 1 - m_mx;
	int pdy = (1 - m_my)*m_mx;
	int pdz = (1 - m_mz)*m_mx*m_my;
	
	m_cell_pair_index[0] = 0;

	//Ë܂łcell̃yA
	int index = 0;
	for( iz=0; iz < m_mz-1; iz++){
		for(iy=0; iy < m_my-1; iy++){
			for(ix=0; ix < m_mx-1; ix++){

			//ڂĂZ+̃ZŒT
			//KڃZ͒TΏۂł͂Ȃ
				imap = ix + iy * dy + iz * dz;
				
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + dx;	//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 2] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 3] = imap + dy;	//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 4] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 5] = imap + dx + dy;		//xicell_2(ix+1, iy+1, iz);
				m_cell_pair[index + 6] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 7] = imap + dz;	//xicell_2(ix, iy, iz+1);
				m_cell_pair[index + 8] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 9] = imap + dx + dz;	//xicell_2(ix+1, iy, iz+1);
				m_cell_pair[index + 10] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 11] = imap + dy + dz;	//xicell_2(ix, iy+1, iz+1);
				m_cell_pair[index + 12] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 13] = imap + dx + dy + dz;	//xicell_2(ix+1, iy+1, iz+1);
				
				m_cell_pair[index + 14] = imap + dx;		//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 15] = imap + dy;		//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 16] = imap + dx;		//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 17] = imap + dz;		//xicell_2(ix, iy, iz+1);
				m_cell_pair[index + 18] = imap + dy;		//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 19] = imap + dz;		//xicell_2(ix, iy, iz+1);

				m_cell_pair[index + 20] = imap + dx;		//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 21] = imap + dy + dz;	//xicell_2(ix, iy+1, iz+1);
				m_cell_pair[index + 22] = imap + dy;		//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 23] = imap + dx + dz;		//xicell_2(ix+1, iy, iz+1);
				m_cell_pair[index + 24] = imap + dz;		//xicell_2(ix, iy, iz+1);
				m_cell_pair[index + 25] = imap + dx + dy;	//xicell_2(ix+1, iy+1, iz);
				
				index += 26;
			}
		}
	}
		
	//zEMM̃ZŋEׂȂ
	iz = m_mz-1;
	for(iy=0; iy < m_my-1; iy++){
		for(ix=0; ix < m_mx-1; ix++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
			imap = ix + iy * dy + iz * dz;
				
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + dx;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + dy;
			m_cell_pair[index + 4] = imap;
			m_cell_pair[index + 5] = imap + dx + dy;
				
			m_cell_pair[index + 6] = imap + dx;
			m_cell_pair[index + 7] = imap + dy;
				
			index += 8;
			
		}
	}
	
	//yEMM̃ZŋEׂȂ
	iy = m_my-1;
	for(iz=0; iz < m_mz-1; iz++){
		for(ix=0; ix < m_mx-1; ix++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
			imap = ix + iy * dy + iz * dz;
				
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + dx;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + dz;
			m_cell_pair[index + 4] = imap;
			m_cell_pair[index + 5] = imap + dx + dz;
				
			m_cell_pair[index + 6] = imap + dx;
			m_cell_pair[index + 7] = imap + dz;
				
			index += 8;
			
		}
	}
	
	//xEMM̃ZŋEׂȂ
	ix = m_mx-1;
	for(iz=0; iz < m_mz-1; iz++){
		for(iy=0; iy < m_my-1; iy++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
			imap = ix + iy * dy + iz * dz;
				
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + dy;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + dz;
			m_cell_pair[index + 4] = imap;
			m_cell_pair[index + 5] = imap + dy + dz;
				
			m_cell_pair[index + 6] = imap + dy;
			m_cell_pair[index + 7] = imap + dz;
				
			index += 8;
			
		}
	}

	//yzGbWŋEׂȂ
	iz = m_mz-1;
	iy = m_my-1;
	for(ix=0; ix < m_mx-1; ix++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
		imap = ix + iy * dy + iz * dz;
				
		m_cell_pair[index] = imap;
		m_cell_pair[index + 1] = imap + dx;
				
		index += 2;
	}
	
	//xzGbWŋEׂȂ
	iz = m_mz-1;
	ix = m_mx-1;
	for(iy=0; iy < m_my-1; iy++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
		imap = ix + iy * dy + iz * dz;
				
		m_cell_pair[index] = imap;
		m_cell_pair[index + 1] = imap + dy;
				
		index += 2;
	}
	
	//xzGbWŋEׂȂ
	iy = m_my-1;
	ix = m_mx-1;
	for(iz=0; iz < m_mz-1; iz++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
		imap = ix + iy * dy + iz * dz;
				
		m_cell_pair[index] = imap;
		m_cell_pair[index + 1] = imap + dz;
				
		index += 2;
	}
	

	
//ExEׂꍇ(Kׂcell)==============
	m_cell_pair_index[1] = index;
	if(m_periodic_flag & FLAG_PERIODIC_X){

		ix = m_mx-1;
		for(iz=0; iz < m_mz; iz++){
			for(iy=0; iy < m_my; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdx;
				index += 2;
			}
		}

		for(iz=0; iz < m_mz; iz++){
			for(iy=0; iy < m_my-1; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdx + dy;
				m_cell_pair[index + 2] = imap + dy;
				m_cell_pair[index + 3] = imap + pdx;
				index += 4;
			}
		}

		for(iz=0; iz < m_mz-1; iz++){
			for(iy=0; iy < m_my; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdx + dz;
				m_cell_pair[index + 2] = imap + dz;
				m_cell_pair[index + 3] = imap + pdx;
				index += 4;
			}
		}

		for(iz=0; iz < m_mz-1; iz++){
			for(iy=0; iy < m_my-1; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + dy + dz;
				m_cell_pair[index + 1] = imap + pdx;
				m_cell_pair[index + 2] = imap + dy;
				m_cell_pair[index + 3] = imap + pdx + dz;
				m_cell_pair[index + 4] = imap + dz;
				m_cell_pair[index + 5] = imap + pdx + dy;
				m_cell_pair[index + 6] = imap;
				m_cell_pair[index + 7] = imap + pdx + dy + dz;
				index += 8;
			}
		}
	}

//EyEׂꍇ==============
	m_cell_pair_index[2] = index;
	if(m_periodic_flag & FLAG_PERIODIC_Y){

		iy = m_my-1;
		for(ix=0; ix < m_mx; ix++){
			for(iz=0; iz < m_mz; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdy;
				index += 2;
			}
		}

		for(ix=0; ix < m_mx; ix++){
			for(iz=0; iz < m_mz-1; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdy + dz;
				m_cell_pair[index + 2] = imap + dz;
				m_cell_pair[index + 3] = imap + pdy;
				index += 4;
			}
		}

		for(ix=0; ix < m_mx-1; ix++){
			for(iz=0; iz < m_mz; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdy + dx;
				m_cell_pair[index + 2] = imap + dx;
				m_cell_pair[index + 3] = imap + pdy;
				index += 4;
			}
		}

		for(ix=0; ix < m_mx-1; ix++){
			for(iz=0; iz < m_mz-1; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + dz + dx;
				m_cell_pair[index + 1] = imap + pdy;
				m_cell_pair[index + 2] = imap + dz;
				m_cell_pair[index + 3] = imap + pdy + dx;
				m_cell_pair[index + 4] = imap + dx;
				m_cell_pair[index + 5] = imap + pdy + dz;
				m_cell_pair[index + 6] = imap;
				m_cell_pair[index + 7] = imap + pdy + dz + dx;
				index += 8;
			}
		}
	}

//EzEׂꍇ==============
	m_cell_pair_index[3] = index;
	if(m_periodic_flag & FLAG_PERIODIC_Z){
		iz = m_mz-1;
		for(iy=0; iy < m_my; iy++){
			for(ix=0; ix < m_mx; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdz;
				index += 2;
			}
		}

		for(iy=0; iy < m_my; iy++){
			for(ix=0; ix < m_mx-1; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdz + dx;
				m_cell_pair[index + 2] = imap + dx;
				m_cell_pair[index + 3] = imap + pdz;
				index += 4;
			}
		}

		for(iy=0; iy < m_my-1; iy++){
			for(ix=0; ix < m_mx; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + dy + pdz;
				m_cell_pair[index + 2] = imap + dy;
				m_cell_pair[index + 3] = imap + pdz;
				index += 4;
			}
		}

		for(iy=0; iy < m_my-1; iy++){
			for(ix=0; ix < m_mx-1; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + dy;
				m_cell_pair[index + 1] = imap + dx + pdz;
				m_cell_pair[index + 2] = imap + dx;
				m_cell_pair[index + 3] = imap + dy + pdz;
				m_cell_pair[index + 4] = imap + dy + dx;
				m_cell_pair[index + 5] = imap + pdz;
				m_cell_pair[index + 6] = imap;
				m_cell_pair[index + 7] = imap + dy + dx + pdz;
				index += 8;
			}
		}
	}
	
//ExyEɌׂꍇ(҂xyɉzcell)==============
	m_cell_pair_index[4] = index;
	if((m_periodic_flag & FLAG_PERIODIC_XY)==FLAG_PERIODIC_XY){

		ix = m_mx-1;
		iy = m_my-1;
		for(iz=0; iz < m_mz; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdx + pdy;
				index += 2;
		}

		for(iz=0; iz < m_mz-1; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + dz;
				m_cell_pair[index + 1] = imap + pdx + pdy;
				m_cell_pair[index + 2] = imap;
				m_cell_pair[index + 3] = imap + pdx + pdy + dz;
				index += 4;
		}

	//ExyEɌׂꍇ(O҂xzcell,҂yzcell)==============
		m_cell_pair_index[5] = index;

		ix = m_mx-1;
		iy = m_my-1;
		for(iz=0; iz < m_mz; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + pdx;
				m_cell_pair[index + 1] = imap + pdy;
				index += 2;
		}

		for(iz=0; iz < m_mz-1; iz++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + pdx;
				m_cell_pair[index + 1] = imap + pdy + dz;
				m_cell_pair[index + 2] = imap + pdx + dz;
				m_cell_pair[index + 3] = imap + pdy;
				index += 4;
		}
	}else{
		m_cell_pair_index[5] = index;
	}


//EyzEɌׂꍇ(҂yzɉzcell)==============
	m_cell_pair_index[6] = index;
	if((m_periodic_flag & FLAG_PERIODIC_YZ)==FLAG_PERIODIC_YZ){

		iy = m_my-1;
		iz = m_mz-1;
		for(ix=0; ix < m_mx; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdy + pdz;
				index += 2;
		}

		for(ix=0; ix < m_mx-1; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + dx;
				m_cell_pair[index + 1] = imap + pdy + pdz;
				m_cell_pair[index + 2] = imap;
				m_cell_pair[index + 3] = imap + pdy + pdz + dx;
				index += 4;
		}
	//EyzEɌׂꍇ(O҂yzcell,҂zzcell)==============
		m_cell_pair_index[7] = index;

		iy = m_my-1;
		iz = m_mz-1;
		for(ix=0; ix < m_mx; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + pdy;
				m_cell_pair[index + 1] = imap + pdz;
				index += 2;
		}

		for(ix=0; ix < m_mx-1; ix++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + pdy;
				m_cell_pair[index + 1] = imap + pdz + dx;
				m_cell_pair[index + 2] = imap + pdy + dx;
				m_cell_pair[index + 3] = imap + pdz;
				index += 4;
		}
	}else{
		m_cell_pair_index[7] = index;
	}

//EzxEɌׂꍇ(҂zxɉzcell)==============
	m_cell_pair_index[8] = index;
	if((m_periodic_flag & FLAG_PERIODIC_ZX)==FLAG_PERIODIC_ZX){

		iz = m_mz-1;
		ix = m_mx-1;
		for(iy=0; iy < m_my; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + pdz + pdx;
				index += 2;
		}

		for(iy=0; iy < m_my-1; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + dy;
				m_cell_pair[index + 1] = imap + pdx + pdz;
				m_cell_pair[index + 2] = imap;
				m_cell_pair[index + 3] = imap + dy + pdx + pdz;
				index += 4;
		}
	//EzxEɌׂꍇ(O҂zzcell,҂xzcell)==============
		m_cell_pair_index[9] = index;

		iz = m_mz-1;
		ix = m_mx-1;
		for(iy=0; iy < m_my; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + pdz;
				m_cell_pair[index + 1] = imap + pdx;
				index += 2;
		}

		for(iy=0; iy < m_my-1; iy++){
				imap = ix + iy * dy + iz * dz;
				m_cell_pair[index] = imap + dy + pdz;
				m_cell_pair[index + 1] = imap + pdx;
				m_cell_pair[index + 2] = imap + pdz;
				m_cell_pair[index + 3] = imap + dy + pdx;
				index += 4;
		}
	}else{
		m_cell_pair_index[9] = index;
	}

//ExyzEɌׂꍇ==============
	m_cell_pair_index[10] = index;
	if((m_periodic_flag & FLAG_PERIODIC_XYZ)==FLAG_PERIODIC_XYZ){

		ix = m_mx-1;
		iy = m_my-1;
		iz = m_mz-1;
				imap = ix + iy * dy + iz * dz;
				//(O҂xzcell,҂yzzcell)
				m_cell_pair[index] = imap + pdx;
				m_cell_pair[index + 1] = imap + pdy + pdz;
				//(O҂yzcell,҂zxzcell)
				m_cell_pair[index + 2] = imap + pdy;
				m_cell_pair[index + 3] = imap + pdx + pdz;
				//(O҂zzcell,҂xyzcell)
				m_cell_pair[index + 4] = imap + pdz;
				m_cell_pair[index + 5] = imap + pdy + pdx;
				//(҂xyzzcell)
				m_cell_pair[index + 6] = imap;
				m_cell_pair[index + 7] = imap + pdy + pdx + pdz;
				index += 8;
	}

	//Z̑
	m_cell_pair_index[11] = index;

				
}


/*
void CellDiv::InitCell(int a_mcx, int a_mcy, int a_mcz){
		

	int ix,iy,iz ,imap;
	
	if(a_mcx < 3){ a_mcx = 3;}
	if(a_mcy < 3){ a_mcy = 3;}
	if(a_mcz < 3){ a_mcz = 3;}


		
	if(m_mcell != a_mcx * a_mcy * a_mcz){
	//if (g_mcell > 0) {
		delete [] m_cell_pair;
		delete [] m_first_in_cell;
		
		m_mcell = a_mcx*a_mcy*a_mcz;
		m_cell_pair = new int[m_mcell*13*2];
		m_first_in_cell = new int[m_mcell];


		printf(_T("allocate %d, %d, %d)\n"),a_mcx,a_mcy,a_mcz);

	}
		
	m_mx = a_mcx;
	m_my = a_mcy;
	m_mz = a_mcz;
	
	int dx = 1;
	int dy = m_mx;
	int dz = m_mx*m_my;
	
	int pdx = 1 - m_mx;
	int pdy = (1 - m_my)*m_mx;
	int pdz = (1 - m_mz)*m_mx*m_my;
	
	m_cell_pair_index[0] = 0;

	//Ë܂łcell̃yA
	int index = 0;
	for( iz=0; iz < m_mz-1; iz++){
		for(iy=0; iy < m_my-1; iy++){
			for(ix=0; ix < m_mx-1; ix++){

			//ڂĂZ+̃ZŒT
			//KڃZ͒TΏۂł͂Ȃ
				imap = ix + iy * dy + iz * dz;
				
				m_cell_pair[index] = imap;
				m_cell_pair[index + 1] = imap + dx;	//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 2] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 3] = imap + dy;	//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 4] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 5] = imap + dx + dy;		//xicell_2(ix+1, iy+1, iz);
				m_cell_pair[index + 6] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 7] = imap + dz;	//xicell_2(ix, iy, iz+1);
				m_cell_pair[index + 8] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 9] = imap + dx + dz;	//xicell_2(ix+1, iy, iz+1);
				m_cell_pair[index + 10] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 11] = imap + dy + dz;	//xicell_2(ix, iy+1, iz+1);
				m_cell_pair[index + 12] = imap;		//xicell_2(ix, iy, iz);
				m_cell_pair[index + 13] = imap + dx + dy + dz;	//xicell_2(ix+1, iy+1, iz+1);
				
				m_cell_pair[index + 14] = imap + dx;		//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 15] = imap + dy;		//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 16] = imap + dx;		//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 17] = imap + dz;		//xicell_2(ix, iy, iz+1);
				m_cell_pair[index + 18] = imap + dy;		//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 19] = imap + dz;		//xicell_2(ix, iy, iz+1);

				m_cell_pair[index + 20] = imap + dx;		//xicell_2(ix+1, iy, iz);
				m_cell_pair[index + 21] = imap + dy + dz;	//xicell_2(ix, iy+1, iz+1);
				m_cell_pair[index + 22] = imap + dy;		//xicell_2(ix, iy+1, iz);
				m_cell_pair[index + 23] = imap + dx + dz;		//xicell_2(ix+1, iy, iz+1);
				m_cell_pair[index + 24] = imap + dz;		//xicell_2(ix, iy, iz+1);
				m_cell_pair[index + 25] = imap + dx + dy;	//xicell_2(ix+1, iy+1, iz);
				
				index += 26;
			}
		}
	}
		
	//zEMM̃ZŋEׂȂ
	iz = m_mz-1;
	for(iy=0; iy < m_my-1; iy++){
		for(ix=0; ix < m_mx-1; ix++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
			imap = ix + iy * dy + iz * dz;
				
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + dx;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + dy;
			m_cell_pair[index + 4] = imap;
			m_cell_pair[index + 5] = imap + dx + dy;
				
			m_cell_pair[index + 6] = imap + dx;
			m_cell_pair[index + 7] = imap + dy;
				
			index += 8;
			
		}
	}
	
	//yEMM̃ZŋEׂȂ
	iy = m_my-1;
	for(iz=0; iz < m_mz-1; iz++){
		for(ix=0; ix < m_mx-1; ix++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
			imap = ix + iy * dy + iz * dz;
				
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + dx;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + dz;
			m_cell_pair[index + 4] = imap;
			m_cell_pair[index + 5] = imap + dx + dz;
				
			m_cell_pair[index + 6] = imap + dx;
			m_cell_pair[index + 7] = imap + dz;
				
			index += 8;
			
		}
	}
	
	//xEMM̃ZŋEׂȂ
	ix = m_mx-1;
	for(iz=0; iz < m_mz-1; iz++){
		for(iy=0; iy < m_my-1; iy++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
			imap = ix + iy * dy + iz * dz;
				
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + dy;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + dz;
			m_cell_pair[index + 4] = imap;
			m_cell_pair[index + 5] = imap + dy + dz;
				
			m_cell_pair[index + 6] = imap + dy;
			m_cell_pair[index + 7] = imap + dz;
				
			index += 8;
			
		}
	}

	//yzGbWŋEׂȂ
	iz = m_mz-1;
	iy = m_my-1;
	for(ix=0; ix < m_mx-1; ix++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
		imap = ix + iy * dy + iz * dz;
				
		m_cell_pair[index] = imap;
		m_cell_pair[index + 1] = imap + dx;
				
		index += 2;
	}
	
	//xzGbWŋEׂȂ
	iz = m_mz-1;
	ix = m_mx-1;
	for(iy=0; iy < m_my-1; iy++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
		imap = ix + iy * dy + iz * dz;
				
		m_cell_pair[index] = imap;
		m_cell_pair[index + 1] = imap + dy;
				
		index += 2;
	}
	
	//xzGbWŋEׂȂ
	iy = m_my-1;
	ix = m_mx-1;
	for(iz=0; iz < m_mz-1; iz++){
	
		//ڂĂZ+̃ZŒT
		//KڃZ͒TΏۂł͂Ȃ
		imap = ix + iy * dy + iz * dz;
				
		m_cell_pair[index] = imap;
		m_cell_pair[index + 1] = imap + dz;
				
		index += 2;
	}
	

	
//ExEׂꍇ(Kׂcell)==============
	m_cell_pair_index[1] = index;
	

	ix = m_mx-1;
	for(iz=0; iz < m_mz; iz++){
		for(iy=0; iy < m_my; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdx;
			index += 2;
		}
	}

	for(iz=0; iz < m_mz; iz++){
		for(iy=0; iy < m_my-1; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdx + dy;
			m_cell_pair[index + 2] = imap + dy;
			m_cell_pair[index + 3] = imap + pdx;
			index += 4;
		}
	}

	for(iz=0; iz < m_mz-1; iz++){
		for(iy=0; iy < m_my; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdx + dz;
			m_cell_pair[index + 2] = imap + dz;
			m_cell_pair[index + 3] = imap + pdx;
			index += 4;
		}
	}

	for(iz=0; iz < m_mz-1; iz++){
		for(iy=0; iy < m_my-1; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + dy + dz;
			m_cell_pair[index + 1] = imap + pdx;
			m_cell_pair[index + 2] = imap + dy;
			m_cell_pair[index + 3] = imap + pdx + dz;
			m_cell_pair[index + 4] = imap + dz;
			m_cell_pair[index + 5] = imap + pdx + dy;
			m_cell_pair[index + 6] = imap;
			m_cell_pair[index + 7] = imap + pdx + dy + dz;
			index += 8;
		}
	}


//EyEׂꍇ==============
	m_cell_pair_index[2] = index;

	iy = m_my-1;
	for(ix=0; ix < m_mx; ix++){
		for(iz=0; iz < m_mz; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdy;
			index += 2;
		}
	}

	for(ix=0; ix < m_mx; ix++){
		for(iz=0; iz < m_mz-1; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdy + dz;
			m_cell_pair[index + 2] = imap + dz;
			m_cell_pair[index + 3] = imap + pdy;
			index += 4;
		}
	}

	for(ix=0; ix < m_mx-1; ix++){
		for(iz=0; iz < m_mz; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdy + dx;
			m_cell_pair[index + 2] = imap + dx;
			m_cell_pair[index + 3] = imap + pdy;
			index += 4;
		}
	}

	for(ix=0; ix < m_mx-1; ix++){
		for(iz=0; iz < m_mz-1; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + dz + dx;
			m_cell_pair[index + 1] = imap + pdy;
			m_cell_pair[index + 2] = imap + dz;
			m_cell_pair[index + 3] = imap + pdy + dx;
			m_cell_pair[index + 4] = imap + dx;
			m_cell_pair[index + 5] = imap + pdy + dz;
			m_cell_pair[index + 6] = imap;
			m_cell_pair[index + 7] = imap + pdy + dz + dx;
			index += 8;
		}
	}

//EzEׂꍇ==============
	m_cell_pair_index[3] = index;

	iz = m_mz-1;
	for(iy=0; iy < m_my; iy++){
		for(ix=0; ix < m_mx; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdz;
			index += 2;
		}
	}

	for(iy=0; iy < m_my; iy++){
		for(ix=0; ix < m_mx-1; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdz + dx;
			m_cell_pair[index + 2] = imap + dx;
			m_cell_pair[index + 3] = imap + pdz;
			index += 4;
		}
	}

	for(iy=0; iy < m_my-1; iy++){
		for(ix=0; ix < m_mx; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + dy + pdz;
			m_cell_pair[index + 2] = imap + dy;
			m_cell_pair[index + 3] = imap + pdz;
			index += 4;
		}
	}

	for(iy=0; iy < m_my-1; iy++){
		for(ix=0; ix < m_mx-1; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + dy;
			m_cell_pair[index + 1] = imap + dx + pdz;
			m_cell_pair[index + 2] = imap + dx;
			m_cell_pair[index + 3] = imap + dy + pdz;
			m_cell_pair[index + 4] = imap + dy + dx;
			m_cell_pair[index + 5] = imap + pdz;
			m_cell_pair[index + 6] = imap;
			m_cell_pair[index + 7] = imap + dy + dx + pdz;
			index += 8;
		}
	}

	
//ExyEɌׂꍇ(҂xyɉzcell)==============
	m_cell_pair_index[4] = index;

	ix = m_mx-1;
	iy = m_my-1;
	for(iz=0; iz < m_mz; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdx + pdy;
			index += 2;
	}

	for(iz=0; iz < m_mz-1; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + dz;
			m_cell_pair[index + 1] = imap + pdx + pdy;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + pdx + pdy + dz;
			index += 4;
	}

//ExyEɌׂꍇ(O҂xzcell,҂yzcell)==============
	m_cell_pair_index[5] = index;

	ix = m_mx-1;
	iy = m_my-1;
	for(iz=0; iz < m_mz; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + pdx;
			m_cell_pair[index + 1] = imap + pdy;
			index += 2;
	}

	for(iz=0; iz < m_mz-1; iz++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + pdx;
			m_cell_pair[index + 1] = imap + pdy + dz;
			m_cell_pair[index + 2] = imap + pdx + dz;
			m_cell_pair[index + 3] = imap + pdy;
			index += 4;
	}


//EyzEɌׂꍇ(҂yzɉzcell)==============
	m_cell_pair_index[6] = index;

	iy = m_my-1;
	iz = m_mz-1;
	for(ix=0; ix < m_mx; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdy + pdz;
			index += 2;
	}

	for(ix=0; ix < m_mx-1; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + dx;
			m_cell_pair[index + 1] = imap + pdy + pdz;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + pdy + pdz + dx;
			index += 4;
	}
//EyzEɌׂꍇ(O҂yzcell,҂zzcell)==============
	m_cell_pair_index[7] = index;

	iy = m_my-1;
	iz = m_mz-1;
	for(ix=0; ix < m_mx; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + pdy;
			m_cell_pair[index + 1] = imap + pdz;
			index += 2;
	}

	for(ix=0; ix < m_mx-1; ix++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + pdy;
			m_cell_pair[index + 1] = imap + pdz + dx;
			m_cell_pair[index + 2] = imap + pdy + dx;
			m_cell_pair[index + 3] = imap + pdz;
			index += 4;
	}

//EzxEɌׂꍇ(҂zxɉzcell)==============
	m_cell_pair_index[8] = index;

	iz = m_mz-1;
	ix = m_mx-1;
	for(iy=0; iy < m_my; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap;
			m_cell_pair[index + 1] = imap + pdz + pdx;
			index += 2;
	}

	for(iy=0; iy < m_my-1; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + dy;
			m_cell_pair[index + 1] = imap + pdx + pdz;
			m_cell_pair[index + 2] = imap;
			m_cell_pair[index + 3] = imap + dy + pdx + pdz;
			index += 4;
	}
//EzxEɌׂꍇ(O҂zzcell,҂xzcell)==============
	m_cell_pair_index[9] = index;

	iz = m_mz-1;
	ix = m_mx-1;
	for(iy=0; iy < m_my; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + pdz;
			m_cell_pair[index + 1] = imap + pdx;
			index += 2;
	}

	for(iy=0; iy < m_my-1; iy++){
			imap = ix + iy * dy + iz * dz;
			m_cell_pair[index] = imap + dy + pdz;
			m_cell_pair[index + 1] = imap + pdx;
			m_cell_pair[index + 2] = imap + pdz;
			m_cell_pair[index + 3] = imap + dy + pdx;
			index += 4;
	}

//ExyzEɌׂꍇ==============
	m_cell_pair_index[10] = index;

	ix = m_mx-1;
	iy = m_my-1;
	iz = m_mz-1;
			imap = ix + iy * dy + iz * dz;
			//(O҂xzcell,҂yzzcell)
			m_cell_pair[index] = imap + pdx;
			m_cell_pair[index + 1] = imap + pdy + pdz;
			//(O҂yzcell,҂zxzcell)
			m_cell_pair[index + 2] = imap + pdy;
			m_cell_pair[index + 3] = imap + pdx + pdz;
			//(O҂zzcell,҂xyzcell)
			m_cell_pair[index + 4] = imap + pdz;
			m_cell_pair[index + 5] = imap + pdy + pdx;
			//(҂xyzzcell)
			m_cell_pair[index + 6] = imap;
			m_cell_pair[index + 7] = imap + pdy + pdx + pdz;
			index += 8;

	//Z̑
	m_cell_pair_index[11] = index;
				
}
*/




//
//======================================================================
//  Subroutine links
//
//  This subroutine sets up linked g_list and the head of chain arrays.
//
//  Principal variables
//		  g_m							  : number of cells in each direction
//		  g_mcell				  : total number of cells (g_m**3)
//		  g_list(ntotal)  : linked g_list of atoms
//		  m_first_in_cell(MXCELL) : head of chain for each cell
//
//				Modified by Atsushi I.	2004/12/2
//
//======================================================================c


void CellDiv::PutIntoCell(int count, vec3d* r, int* knd){
//void MD::NewLinksFold(){

		
	double xi,yi,zi;
	double cx,cy,cz;
	int icell,i;

	// set zero head of chain array
	memset(m_first_in_cell, -1, m_mcell * sizeof(int));
			
	
	for( i = 0; i < count ; i++){
		
		if (knd[i] < -1) continue;
		
		xi = r[i].x * m_boxi.x;
		xi = modf(xi+1.0, &cx);
//		m_cycle_x[i] += (int)cx;
//		m_cycle_x[i] --;
		r[i].x = xi * m_box.x;
		
		yi = r[i].y * m_boxi.y;
		yi = modf(yi+1.0, &cy);
//		m_cycle_y[i] += (int)cy;
//		m_cycle_y[i] --;
		r[i].y = yi * m_box.y;
		
		zi = r[i].z * m_boxi.z;
		zi = modf(zi+1.0, &cz);
//		m_cycle_z[i] += (int)cz;
//		m_cycle_z[i] --;
		r[i].z = zi * m_box.z;

		icell = (int)floor(xi * (double)(m_mx)) + ( (int)floor(yi * (double)(m_my)) + (int)floor(zi * (double)(m_mz))*m_my )*m_mx;
	


		m_inext[i] = m_first_in_cell[icell];
		m_first_in_cell[icell] = i;
		
	}

}

void CellDiv::PutIntoCellNonortho(int count, vec3d* r, int* knd){
//void MD::NewLinksNonortho(){

		
	//double xi,yi,zi;
	double cx,cy,cz;
	int icell,i;

	mat33d iAm = Inverse(m_Am);
	vec3d r_prim;

	// set zero head of chain array
	memset(m_first_in_cell, -1, m_mcell * sizeof(int));
			

	for( i = 0; i < count; i++){
		
		if (knd[i] < -1) continue;
		
		r_prim = iAm * r[i];

		r_prim.x = modf(r_prim.x+1.0, &cx);
//		m_cycle_x[i] += (int)cx;
//		m_cycle_x[i] --;
		
		r_prim.y = modf(r_prim.y+1.0, &cy);
//		m_cycle_y[i] += (int)cy;
//		m_cycle_y[i] --;
		
		r_prim.z = modf(r_prim.z+1.0, &cz);
//		m_cycle_z[i] += (int)cz;
//		m_cycle_z[i] --;
		
		r[i] = m_Am * r_prim;

		icell = (int)(r_prim.x * (double)(m_mx)) + ( (int)(r_prim.y * (double)(m_my)) + (int)(r_prim.z * (double)(m_mz))*m_my )*m_mx;
	

		m_inext[i] = m_first_in_cell[icell];
		m_first_in_cell[icell] = i;
		
	}

	//*first_in_cell = m_first_in_cell;
}

int CellDiv::GetCellInfo(CELLDIV_INFO* celldiv_info){

	celldiv_info->cellall = m_mcell;
	celldiv_info->cell_pair = m_cell_pair;
	celldiv_info->first_in_cell = m_first_in_cell;
	celldiv_info->inext = m_inext;
	
	memcpy(celldiv_info->cell_pair_index, m_cell_pair_index, 12 * sizeof(int));

	return m_mcell;

}