
#include "eventDX11.h"
#include "mod.h"
#include "visual.h"
#include "camera.h"

#include "InstanceRenderer.h"
#include "PointSpriteRenderer.h"

#include "MDLoader.h"
#include "filelist.h"


//DirectX11 system//////////////////////////////
static CommonShader* comShader = NULL;
static CommonTexture* comTexture = NULL;

static InstanceRenderer* instRdr = NULL;
static PointSpriteRenderer* psRdr = NULL;

//polygon//////////////////////////////////////////////
static vec3f* flier_vertex;
static int flier_vertex_count;
static WORD* flier_index;
static int flier_index_count;


extern int g_client_w;
extern int g_client_h;
		
extern int g_visual_atom;
extern int g_visual_atompoly;
extern float bgcolor_reset[4];
extern CameraGL* g_camera;


extern MasterFileList g_files;		//Jt@C̃Xg.
extern bool g_updateFlag;	//_OȂ悤LockB]Ȃ.

///////////////////////////////////////////////////////////////////
//ϊspCu
///////////////////////////////////////////////////////////////////

static void SetViewMatrix(vec3f* target, vec3f* origin, vec3f* up, mat44f* pViewMatrix);
static void SetProjectionPerspectiveMatrix(float angle, float wph, float z_near, float z_far, mat44f* pProjectionMatrix);



///////////////////////////////////////////////////////////////////
//ȉ̓[U[`̃R[obN֐
///////////////////////////////////////////////////////////////////

void InitDX11(DX11_CORE* dx11_core){
	
	//ShaderpǗNX
	comShader = new CommonShader(dx11_core->pd3dDevice);
	//TexturepǗNX
	comTexture = new CommonTexture(dx11_core->pd3dDevice);

	//_̏		
	instRdr = new InstanceRenderer(dx11_core, comShader, comTexture, (sizeof(float)*6)*1, sizeof(UINT)*3);
	instRdr->InitShader();

	psRdr = new PointSpriteRenderer(dx11_core, comShader, comTexture, _T("particle.dds"));
	psRdr->InitShader();
	
	//q|S.
	CreatePolygonSphere(0.5f, g_visual_atompoly, g_visual_atompoly*2, &flier_vertex, &flier_vertex_count, &flier_index, &flier_index_count);


}

void TerminateDX11(){
	if(instRdr){ delete instRdr;}
	if(psRdr){ delete psRdr;}
	
	if(comShader){ delete comShader;}
	if(comTexture){ delete comTexture;}

}

void DisplayDX11(DX11_CORE* dx11_core){



	
	if (g_visual_atom == VISUAL_ATOM_POINT){

		//`̃Zbg///////////////////////////////////////////
		 //BackBuffer̃NA
		dx11_core->pd3dDC->ClearRenderTargetView( dx11_core->pRenderTargetView, bgcolor_reset );
	    
		//DepthBuffer̃NA
		dx11_core->pd3dDC->ClearDepthStencilView( dx11_core->pDepthStencilView, D3D11_CLEAR_DEPTH, 1.0f, 0);

		//ϊsvZ
		vec3f target, camera, up;
		g_camera->GetFloatInfo(&target, &camera, &up);
		mat44f view_matrix;
		SetViewMatrix(&target, &camera, &up, &view_matrix); 
		
		mat44f projection_matrix;
		SetProjectionPerspectiveMatrix((float)(20.0f/180.0f*PI), (float)g_client_w/(float)g_client_h, 10.0f, 10000.0f, &projection_matrix);
		

		//_O///////////////////////////////////////////

		//q̕\.
		psRdr->SetViewMatrixPointer( &view_matrix );
		psRdr->SetProjectionMatrixPointer( &projection_matrix );
		ATOMS_DATA* dat = g_files.first->atm->GetDataPointer();
		if(g_updateFlag){
			psRdr->UpdateVertexBuffer(dat->r, dat->pcnt, sizeof(vec3f));	//_f[^VRAMɓ]
			
			g_updateFlag = false;
		}
		//float ins_color[] = {1.0f, 1.0f, 0.4f, 1.0f};
		//psRdr->Materialfv(DOG_FRONT_AND_BACK, DOG_AMBIENT_AND_DIFFUSE, ins_color);
		
		psRdr->Enable(DOG_BLEND);
		psRdr->BlendFunc(DOG_SRC_ALPHA, DOG_ONE_MINUS_SRC_ALPHA);
		psRdr->Draw(dat->pcnt, NULL);
		psRdr->Disable(DOG_BLEND);


	}else if(g_visual_atom == VISUAL_ATOM_SPHERE){

		//`̃Zbg///////////////////////////////////////////
		 //BackBuffer̃NA
		dx11_core->pd3dDC->ClearRenderTargetView( dx11_core->pRenderTargetView, bgcolor_reset );
	    
		//DepthBuffer̃NA
		dx11_core->pd3dDC->ClearDepthStencilView( dx11_core->pDepthStencilView, D3D11_CLEAR_DEPTH, 1.0f, 0);

		//ϊsvZ
		vec3f target, camera, up;
		g_camera->GetFloatInfo(&target, &camera, &up);
		mat44f view_matrix;
		SetViewMatrix(&target, &camera, &up, &view_matrix); 
		
		mat44f projection_matrix;
		SetProjectionPerspectiveMatrix((float)(20.0f/180.0f*PI), (float)g_client_w/(float)g_client_h, 10.0f, 10000.0f, &projection_matrix);
		

		//_O///////////////////////////////////////////

		//q̕\.
		instRdr->SetViewMatrixPointer( &view_matrix );
		instRdr->SetProjectionMatrixPointer( &projection_matrix );
		ATOMS_DATA* dat = g_files.first->atm->GetDataPointer();
		if(g_updateFlag){
			instRdr->UpdateVertexBuffer(flier_vertex, flier_vertex_count, sizeof(vec3f)*2);	//_f[^VRAMɓ]
			instRdr->UpdateIndexBuffer(flier_index, flier_index_count, sizeof(WORD));	//CfbNXf[^VRAMɓ]
			instRdr->UpdateInstanceBuffer(dat->r, dat->pcnt, sizeof(vec3f));

			g_updateFlag = false;
		}
		float ins_color[] = {1.0f, 1.0f, 0.4f, 1.0f};
		instRdr->Materialfv(DOG_FRONT_AND_BACK, DOG_AMBIENT_AND_DIFFUSE, ins_color);
		instRdr->Draw(flier_index_count, dat->pcnt);
	}
	

}


///////////////////////////////////////////////////////////////////
//ϊspCu
///////////////////////////////////////////////////////////////////

void SetViewMatrix(vec3f* target, vec3f* origin, vec3f* up, mat44f* pViewMatrix){
	
	/////////////////////////////////////////////////////////////////////
	//WnorEWn͂Ō܂//
	//Wn : ʉEx,ʏyƂƂ,ʉz//
	vec3f cx;
	vec3f cy;
	vec3f cz = *target - *origin;	//ʉzɂƂ//
	cz.Normalize();
	cy = (*up) - cz * ((*up) * cz);	//ʏyɂƂ//
	cy.Normalize();
	cx = Cross(cz, cy);				//ʉExɂƂ//
	////////////////////////////////////////////////////////////////////////

	//eƂ̓ςӖs//
	pViewMatrix->Set( cx.x, cy.x, cz.x, 0.0f,
			  cx.y, cy.y, cz.y, 0.0f,
			  cx.z, cy.z, cz.z, 0.0f,
			  -(cx * (*origin)), -(cy * (*origin)), -(cz * (*origin)), 1.0f);

}

void SetProjectionPerspectiveMatrix(float angle, float wph, float z_near, float z_far, mat44f* pProjectionMatrix){
	pProjectionMatrix->Clear();

	pProjectionMatrix->m11 = 1.0f / tan(angle);
	pProjectionMatrix->m22 = pProjectionMatrix->m11 * wph;
	pProjectionMatrix->m33 = z_far / (z_far - z_near);
	pProjectionMatrix->m43 = - z_near * pProjectionMatrix->m33;
	pProjectionMatrix->m34 = 1.0f;
	pProjectionMatrix->m44 = 0.0f;

	//change to coordinate DirectX to OpenGL//
	//pProjectionMatrix->m11 = - pProjectionMatrix->m11;
	/*
	pProjectionMatrix->m13 = - pProjectionMatrix->m13;
	pProjectionMatrix->m23 = - pProjectionMatrix->m23;
	pProjectionMatrix->m33 = - pProjectionMatrix->m33;
	pProjectionMatrix->m43 = - pProjectionMatrix->m43;
	*/
}