
#ifndef __filelist_h__
#define __filelist_h__


#include "MDLoader.h"
#include "Field3DLoader.h"
#include "trajectory.h"

#include "AtomRendererGL.h"

#define FILETYPE_NULL	0
#define FILETYPE_ATOM	1
#define FILETYPE_TRAJ	2
#define FILETYPE_FIELD	3



struct FileList{
	FileList* next;
	TCHAR* filepath;
	size_t dirlen;		//directory̍Ō\܂Ŋ܂񂾒
	TCHAR* filename;	//filepath̐擪ʒu
	TCHAR* ext;			//filepath̐擪ʒu
	int type;

	//t@C[_[.
	union{
		MDLoader* atm;
		BCALoader* bca;
		Field3DLoader* field;
	};

	//_[.
	union{
		AtomRendererGL* atomRenderer;
	};


	FileList(){
		//next = NULL;
		type = FILETYPE_NULL;
		filepath = NULL;
		dirlen = 0;

	};
	virtual ~FileList(){
		delete [] filepath;
		switch(type){
			case FILETYPE_ATOM:	
				delete atm;	
				delete atomRenderer;	
				break;
			case FILETYPE_TRAJ:	
				delete bca;
				break;
			case FILETYPE_FIELD:	
				delete field;	
				break;
		}
	};
};


class MasterFileList {
public:
	FileList* first;
	FileList* current;

	MasterFileList(){
		current = first = NULL;
	};

	virtual ~MasterFileList(){
		for(FileList* element = first; element != NULL; ){
			FileList* prev = element;
			element = element->next;
			delete prev;
		}

	};

	void PushFirst(FileList* element){
		element->next = first;
		first = element;
		current = first;
	};


	FileList* Add(){
		FileList* element = new FileList();
		element->next = first;
		first = element;
		current = first;

		return first;
	};

};



#endif	//__filelist_h__