//////////////////////////////////////////////////////////////
//
//		Rough Wrapper of DirectX and OpenGl (rowdog)
//
//////////////////////////////////////////////////////////////

#include "rowdog.h"


///////////////////////////////////////////////////////////////////
//ϊspCu
///////////////////////////////////////////////////////////////////

void SetViewMatrix(vec3f* target, vec3f* origin, vec3f* up, mat44f* pViewMatrix){
	
	vec3f cx;
	vec3f cy;
	vec3f cz = *target - *origin;
	cz.Normalize();
	cy = (*up) - cz * ((*up) * cz);
	cy.Normalize();
	cx = Cross(cy, cz);

	pViewMatrix->Set( cx.x, cy.x, cz.x, 0.0f,
			  cx.y, cy.y, cz.y, 0.0f,
			  cx.z, cy.z, cz.z, 0.0f,
			  -(cx * (*origin)), -(cy * (*origin)), -(cz * (*origin)), 1.0f);

}

void SetProjectionPerspectiveMatrix(float angle, float wph, float z_near, float z_far, mat44f* pProjectionMatrix){
	pProjectionMatrix->Clear();

	pProjectionMatrix->m11 = 1.0f / tan(angle);
	pProjectionMatrix->m22 = pProjectionMatrix->m11 * wph;
	pProjectionMatrix->m33 = z_far / (z_far - z_near);
	pProjectionMatrix->m43 = - z_near * pProjectionMatrix->m33;
	pProjectionMatrix->m34 = 1.0f;
	pProjectionMatrix->m44 = 0.0f;


}